/* A Bison parser, made by GNU Bison 3.7.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2020 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30704

/* Bison version string.  */
#define YYBISON_VERSION "3.7.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1


/* Substitute the variable and function names.  */
#define yyparse         hlsl_parse
#define yylex           hlsl_lex
#define yyerror         hlsl_error
#define yydebug         hlsl_debug
#define yynerrs         hlsl_nerrs
#define yylval          hlsl_lval
#define yychar          hlsl_char
#define yylloc          hlsl_lloc

/* First part of user prologue.  */
#line 21 "dlls/d3dcompiler_43/hlsl.y"

#include "wine/debug.h"

#include <limits.h>
#include <stdio.h>

#include "d3dcompiler_private.h"

WINE_DEFAULT_DEBUG_CHANNEL(hlsl_parser);

int hlsl_lex(void);

struct hlsl_parse_ctx hlsl_ctx;

struct YYLTYPE;
static struct source_location get_location(const struct YYLTYPE *l);

void WINAPIV hlsl_message(const char *fmt, ...)
{
    __ms_va_list args;

    __ms_va_start(args, fmt);
    compilation_message(&hlsl_ctx.messages, fmt, args);
    __ms_va_end(args);
}

static const char *hlsl_get_error_level_name(enum hlsl_error_level level)
{
    static const char * const names[] =
    {
        "error",
        "warning",
        "note",
    };
    return names[level];
}

void WINAPIV hlsl_report_message(const struct source_location loc,
        enum hlsl_error_level level, const char *fmt, ...)
{
    __ms_va_list args;
    char *string = NULL;
    int rc, size = 0;

    while (1)
    {
        __ms_va_start(args, fmt);
        rc = vsnprintf(string, size, fmt, args);
        __ms_va_end(args);

        if (rc >= 0 && rc < size)
            break;

        if (rc >= size)
            size = rc + 1;
        else
            size = size ? size * 2 : 32;

        if (!string)
            string = d3dcompiler_alloc(size);
        else
            string = d3dcompiler_realloc(string, size);
        if (!string)
        {
            ERR("Error reallocating memory for a string.\n");
            return;
        }
    }

    hlsl_message("%s:%u:%u: %s: %s\n", loc.file, loc.line, loc.col,
            hlsl_get_error_level_name(level), string);
    d3dcompiler_free(string);

    if (level == HLSL_LEVEL_ERROR)
        set_parse_status(&hlsl_ctx.status, PARSE_ERR);
    else if (level == HLSL_LEVEL_WARNING)
        set_parse_status(&hlsl_ctx.status, PARSE_WARN);
}

static void hlsl_error(const char *s)
{
    const struct source_location loc =
    {
        .file = hlsl_ctx.source_file,
        .line = hlsl_ctx.line_no,
        .col = hlsl_ctx.column,
    };
    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "%s", s);
}

static void debug_dump_decl(struct hlsl_type *type, DWORD modifiers, const char *declname, unsigned int line_no)
{
    TRACE("Line %u: ", line_no);
    if (modifiers)
        TRACE("%s ", debug_modifiers(modifiers));
    TRACE("%s %s;\n", debug_hlsl_type(type), declname);
}

static void check_invalid_matrix_modifiers(DWORD modifiers, struct source_location loc)
{
    if (modifiers & HLSL_MODIFIERS_MAJORITY_MASK)
    {
        hlsl_report_message(loc, HLSL_LEVEL_ERROR,
                "'row_major' or 'column_major' modifiers are only allowed for matrices");
    }
}

static BOOL type_is_single_reg(const struct hlsl_type *type)
{
    return type->type == HLSL_CLASS_SCALAR || type->type == HLSL_CLASS_VECTOR;
}

static BOOL declare_variable(struct hlsl_ir_var *decl, BOOL local)
{
    BOOL ret;

    TRACE("Declaring variable %s.\n", decl->name);
    if (decl->data_type->type != HLSL_CLASS_MATRIX)
        check_invalid_matrix_modifiers(decl->modifiers, decl->loc);

    if (local)
    {
        DWORD invalid = decl->modifiers & (HLSL_STORAGE_EXTERN | HLSL_STORAGE_SHARED
                | HLSL_STORAGE_GROUPSHARED | HLSL_STORAGE_UNIFORM);
        if (invalid)
        {
            hlsl_report_message(decl->loc, HLSL_LEVEL_ERROR,
                    "modifier '%s' invalid for local variables", debug_modifiers(invalid));
        }
        if (decl->semantic)
        {
            hlsl_report_message(decl->loc, HLSL_LEVEL_ERROR,
                    "semantics are not allowed on local variables");
            return FALSE;
        }
    }
    else
    {
        if (find_function(decl->name))
        {
            hlsl_report_message(decl->loc, HLSL_LEVEL_ERROR, "redefinition of '%s'", decl->name);
            return FALSE;
        }
    }
    ret = add_declaration(hlsl_ctx.cur_scope, decl, local);
    if (!ret)
    {
        struct hlsl_ir_var *old = get_variable(hlsl_ctx.cur_scope, decl->name);

        hlsl_report_message(decl->loc, HLSL_LEVEL_ERROR, "\"%s\" already declared", decl->name);
        hlsl_report_message(old->loc, HLSL_LEVEL_NOTE, "\"%s\" was previously declared here", old->name);
        return FALSE;
    }
    return TRUE;
}

static DWORD add_modifiers(DWORD modifiers, DWORD mod, const struct source_location loc)
{
    if (modifiers & mod)
    {
        hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifier '%s' already specified", debug_modifiers(mod));
        return modifiers;
    }
    if ((mod & HLSL_MODIFIERS_MAJORITY_MASK) && (modifiers & HLSL_MODIFIERS_MAJORITY_MASK))
    {
        hlsl_report_message(loc, HLSL_LEVEL_ERROR, "more than one matrix majority keyword");
        return modifiers;
    }
    return modifiers | mod;
}

static BOOL add_type_to_scope(struct hlsl_scope *scope, struct hlsl_type *def)
{
    if (get_type(scope, def->name, FALSE))
        return FALSE;

    wine_rb_put(&scope->types, def->name, &def->scope_entry);
    return TRUE;
}

static void declare_predefined_types(struct hlsl_scope *scope)
{
    struct hlsl_type *type;
    unsigned int x, y, bt;
    static const char * const names[] =
    {
        "float",
        "half",
        "double",
        "int",
        "uint",
        "bool",
    };
    char name[10];

    static const char *const sampler_names[] =
    {
        "sampler",
        "sampler1D",
        "sampler2D",
        "sampler3D",
        "samplerCUBE"
    };

    for (bt = 0; bt <= HLSL_TYPE_LAST_SCALAR; ++bt)
    {
        for (y = 1; y <= 4; ++y)
        {
            for (x = 1; x <= 4; ++x)
            {
                sprintf(name, "%s%ux%u", names[bt], y, x);
                type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_MATRIX, bt, x, y);
                add_type_to_scope(scope, type);

                if (y == 1)
                {
                    sprintf(name, "%s%u", names[bt], x);
                    type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_VECTOR, bt, x, y);
                    add_type_to_scope(scope, type);
                    hlsl_ctx.builtin_types.vector[bt][x - 1] = type;

                    if (x == 1)
                    {
                        sprintf(name, "%s", names[bt]);
                        type = new_hlsl_type(d3dcompiler_strdup(name), HLSL_CLASS_SCALAR, bt, x, y);
                        add_type_to_scope(scope, type);
                        hlsl_ctx.builtin_types.scalar[bt] = type;
                    }
                }
            }
        }
    }

    for (bt = 0; bt <= HLSL_SAMPLER_DIM_MAX; ++bt)
    {
        type = new_hlsl_type(d3dcompiler_strdup(sampler_names[bt]), HLSL_CLASS_OBJECT, HLSL_TYPE_SAMPLER, 1, 1);
        type->sampler_dim = bt;
        hlsl_ctx.builtin_types.sampler[bt] = type;
    }

    hlsl_ctx.builtin_types.Void = new_hlsl_type(d3dcompiler_strdup("void"), HLSL_CLASS_OBJECT, HLSL_TYPE_VOID, 1, 1);

    /* DX8 effects predefined types */
    type = new_hlsl_type(d3dcompiler_strdup("DWORD"), HLSL_CLASS_SCALAR, HLSL_TYPE_INT, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("FLOAT"), HLSL_CLASS_SCALAR, HLSL_TYPE_FLOAT, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("VECTOR"), HLSL_CLASS_VECTOR, HLSL_TYPE_FLOAT, 4, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("MATRIX"), HLSL_CLASS_MATRIX, HLSL_TYPE_FLOAT, 4, 4);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("STRING"), HLSL_CLASS_OBJECT, HLSL_TYPE_STRING, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("TEXTURE"), HLSL_CLASS_OBJECT, HLSL_TYPE_TEXTURE, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("PIXELSHADER"), HLSL_CLASS_OBJECT, HLSL_TYPE_PIXELSHADER, 1, 1);
    add_type_to_scope(scope, type);
    type = new_hlsl_type(d3dcompiler_strdup("VERTEXSHADER"), HLSL_CLASS_OBJECT, HLSL_TYPE_VERTEXSHADER, 1, 1);
    add_type_to_scope(scope, type);
}

static BOOL type_is_void(const struct hlsl_type *type)
{
    return type->type == HLSL_CLASS_OBJECT && type->base_type == HLSL_TYPE_VOID;
}

static struct hlsl_ir_if *new_if(struct hlsl_ir_node *condition, struct source_location loc)
{
    struct hlsl_ir_if *iff;

    if (!(iff = d3dcompiler_alloc(sizeof(*iff))))
        return NULL;
    init_node(&iff->node, HLSL_IR_IF, NULL, loc);
    hlsl_src_from_node(&iff->condition, condition);
    list_init(&iff->then_instrs);
    list_init(&iff->else_instrs);
    return iff;
}

static BOOL append_conditional_break(struct list *cond_list)
{
    struct hlsl_ir_node *condition, *not;
    struct hlsl_ir_jump *jump;
    struct hlsl_ir_if *iff;

    /* E.g. "for (i = 0; ; ++i)". */
    if (!list_count(cond_list))
        return TRUE;

    condition = node_from_list(cond_list);
    if (!(not = new_unary_expr(HLSL_IR_UNOP_LOGIC_NOT, condition, condition->loc)))
    {
        ERR("Out of memory.\n");
        return FALSE;
    }
    list_add_tail(cond_list, &not->entry);

    if (!(iff = new_if(not, condition->loc)))
    {
        ERR("Out of memory.\n");
        return FALSE;
    }
    list_add_tail(cond_list, &iff->node.entry);

    if (!(jump = d3dcompiler_alloc(sizeof(*jump))))
    {
        ERR("Out of memory.\n");
        return FALSE;
    }
    init_node(&jump->node, HLSL_IR_JUMP, NULL, condition->loc);
    jump->type = HLSL_IR_JUMP_BREAK;
    list_add_head(&iff->then_instrs, &jump->node.entry);
    return TRUE;
}

enum loop_type
{
    LOOP_FOR,
    LOOP_WHILE,
    LOOP_DO_WHILE
};

static struct list *create_loop(enum loop_type type, struct list *init, struct list *cond,
        struct list *iter, struct list *body, struct source_location loc)
{
    struct list *list = NULL;
    struct hlsl_ir_loop *loop = NULL;
    struct hlsl_ir_if *cond_jump = NULL;

    list = d3dcompiler_alloc(sizeof(*list));
    if (!list)
        goto oom;
    list_init(list);

    if (init)
        list_move_head(list, init);

    loop = d3dcompiler_alloc(sizeof(*loop));
    if (!loop)
        goto oom;
    init_node(&loop->node, HLSL_IR_LOOP, NULL, loc);
    list_add_tail(list, &loop->node.entry);
    list_init(&loop->body);

    if (!append_conditional_break(cond))
        goto oom;

    if (type != LOOP_DO_WHILE)
        list_move_tail(&loop->body, cond);

    list_move_tail(&loop->body, body);

    if (iter)
        list_move_tail(&loop->body, iter);

    if (type == LOOP_DO_WHILE)
        list_move_tail(&loop->body, cond);

    d3dcompiler_free(init);
    d3dcompiler_free(cond);
    d3dcompiler_free(body);
    return list;

oom:
    ERR("Out of memory.\n");
    d3dcompiler_free(loop);
    d3dcompiler_free(cond_jump);
    d3dcompiler_free(list);
    free_instr_list(init);
    free_instr_list(cond);
    free_instr_list(iter);
    free_instr_list(body);
    return NULL;
}

static unsigned int initializer_size(const struct parse_initializer *initializer)
{
    unsigned int count = 0, i;

    for (i = 0; i < initializer->args_count; ++i)
    {
        count += components_count_type(initializer->args[i]->data_type);
    }
    TRACE("Initializer size = %u.\n", count);
    return count;
}

static void free_parse_initializer(struct parse_initializer *initializer)
{
    free_instr_list(initializer->instrs);
    d3dcompiler_free(initializer->args);
}

static struct hlsl_ir_swizzle *new_swizzle(DWORD s, unsigned int components,
        struct hlsl_ir_node *val, struct source_location *loc)
{
    struct hlsl_ir_swizzle *swizzle = d3dcompiler_alloc(sizeof(*swizzle));

    if (!swizzle)
        return NULL;
    init_node(&swizzle->node, HLSL_IR_SWIZZLE,
            new_hlsl_type(NULL, HLSL_CLASS_VECTOR, val->data_type->base_type, components, 1), *loc);
    hlsl_src_from_node(&swizzle->val, val);
    swizzle->swizzle = s;
    return swizzle;
}

static struct hlsl_ir_swizzle *get_swizzle(struct hlsl_ir_node *value, const char *swizzle,
        struct source_location *loc)
{
    unsigned int len = strlen(swizzle), component = 0;
    unsigned int i, set, swiz = 0;
    BOOL valid;

    if (value->data_type->type == HLSL_CLASS_MATRIX)
    {
        /* Matrix swizzle */
        BOOL m_swizzle;
        unsigned int inc, x, y;

        if (len < 3 || swizzle[0] != '_')
            return NULL;
        m_swizzle = swizzle[1] == 'm';
        inc = m_swizzle ? 4 : 3;

        if (len % inc || len > inc * 4)
            return NULL;

        for (i = 0; i < len; i += inc)
        {
            if (swizzle[i] != '_')
                return NULL;
            if (m_swizzle)
            {
                if (swizzle[i + 1] != 'm')
                    return NULL;
                y = swizzle[i + 2] - '0';
                x = swizzle[i + 3] - '0';
            }
            else
            {
                y = swizzle[i + 1] - '1';
                x = swizzle[i + 2] - '1';
            }

            if (x >= value->data_type->dimx || y >= value->data_type->dimy)
                return NULL;
            swiz |= (y << 4 | x) << component * 8;
            component++;
        }
        return new_swizzle(swiz, component, value, loc);
    }

    /* Vector swizzle */
    if (len > 4)
        return NULL;

    for (set = 0; set < 2; ++set)
    {
        valid = TRUE;
        component = 0;
        for (i = 0; i < len; ++i)
        {
            char c[2][4] = {{'x', 'y', 'z', 'w'}, {'r', 'g', 'b', 'a'}};
            unsigned int s = 0;

            for (s = 0; s < 4; ++s)
            {
                if (swizzle[i] == c[set][s])
                    break;
            }
            if (s == 4)
            {
                valid = FALSE;
                break;
            }

            if (s >= value->data_type->dimx)
                return NULL;
            swiz |= s << component * 2;
            component++;
        }
        if (valid)
            return new_swizzle(swiz, component, value, loc);
    }

    return NULL;
}

static struct hlsl_ir_var *new_var(const char *name, struct hlsl_type *type, const struct source_location loc,
        const char *semantic, unsigned int modifiers, const struct reg_reservation *reg_reservation)
{
    struct hlsl_ir_var *var;

    if (!(var = d3dcompiler_alloc(sizeof(*var))))
    {
        hlsl_ctx.status = PARSE_ERR;
        return NULL;
    }

    var->name = name;
    var->data_type = type;
    var->loc = loc;
    var->semantic = semantic;
    var->modifiers = modifiers;
    var->reg_reservation = reg_reservation;
    return var;
}

static struct hlsl_ir_var *new_synthetic_var(const char *name, struct hlsl_type *type,
        const struct source_location loc)
{
    struct hlsl_ir_var *var = new_var(strdup(name), type, loc, NULL, 0, NULL);

    if (var)
        list_add_tail(&hlsl_ctx.globals->vars, &var->scope_entry);
    return var;
}

static struct hlsl_ir_assignment *new_assignment(struct hlsl_ir_var *var, struct hlsl_ir_node *offset,
        struct hlsl_ir_node *rhs, unsigned int writemask, struct source_location loc)
{
    struct hlsl_ir_assignment *assign;

    if (!writemask && type_is_single_reg(rhs->data_type))
        writemask = (1 << rhs->data_type->dimx) - 1;

    if (!(assign = d3dcompiler_alloc(sizeof(*assign))))
        return NULL;

    init_node(&assign->node, HLSL_IR_ASSIGNMENT, NULL, loc);
    assign->lhs.var = var;
    hlsl_src_from_node(&assign->lhs.offset, offset);
    hlsl_src_from_node(&assign->rhs, rhs);
    assign->writemask = writemask;
    return assign;
}

static struct hlsl_ir_assignment *new_simple_assignment(struct hlsl_ir_var *lhs, struct hlsl_ir_node *rhs)
{
    return new_assignment(lhs, NULL, rhs, 0, rhs->loc);
}

static struct hlsl_ir_jump *add_return(struct list *instrs,
        struct hlsl_ir_node *return_value, struct source_location loc)
{
    struct hlsl_type *return_type = hlsl_ctx.cur_function->return_type;
    struct hlsl_ir_jump *jump;

    if (return_value)
    {
        struct hlsl_ir_assignment *assignment;

        if (!(return_value = add_implicit_conversion(instrs, return_value, return_type, &loc)))
            return NULL;

        if (!(assignment = new_simple_assignment(hlsl_ctx.cur_function->return_var, return_value)))
            return NULL;
        list_add_after(&return_value->entry, &assignment->node.entry);
    }
    else if (!type_is_void(return_type))
    {
        hlsl_report_message(loc, HLSL_LEVEL_ERROR, "non-void function must return a value");
        return NULL;
    }

    if (!(jump = d3dcompiler_alloc(sizeof(*jump))))
    {
        ERR("Out of memory\n");
        return NULL;
    }
    init_node(&jump->node, HLSL_IR_JUMP, NULL, loc);
    jump->type = HLSL_IR_JUMP_RETURN;
    list_add_tail(instrs, &jump->node.entry);

    return jump;
}

static struct hlsl_ir_constant *new_uint_constant(unsigned int n, const struct source_location loc)
{
    struct hlsl_ir_constant *c;

    if (!(c = d3dcompiler_alloc(sizeof(*c))))
        return NULL;
    init_node(&c->node, HLSL_IR_CONSTANT, hlsl_ctx.builtin_types.scalar[HLSL_TYPE_UINT], loc);
    c->value.u[0] = n;
    return c;
}

struct hlsl_ir_node *new_unary_expr(enum hlsl_ir_expr_op op, struct hlsl_ir_node *arg, struct source_location loc)
{
    struct hlsl_ir_expr *expr;

    if (!(expr = d3dcompiler_alloc(sizeof(*expr))))
        return NULL;
    init_node(&expr->node, HLSL_IR_EXPR, arg->data_type, loc);
    expr->op = op;
    hlsl_src_from_node(&expr->operands[0], arg);
    return &expr->node;
}

struct hlsl_ir_node *new_binary_expr(enum hlsl_ir_expr_op op,
        struct hlsl_ir_node *arg1, struct hlsl_ir_node *arg2)
{
    struct hlsl_ir_expr *expr;

    assert(compare_hlsl_types(arg1->data_type, arg2->data_type));

    if (!(expr = d3dcompiler_alloc(sizeof(*expr))))
        return NULL;
    init_node(&expr->node, HLSL_IR_EXPR, arg1->data_type, arg1->loc);
    expr->op = op;
    hlsl_src_from_node(&expr->operands[0], arg1);
    hlsl_src_from_node(&expr->operands[1], arg2);
    return &expr->node;
}

static struct hlsl_ir_load *new_var_load(struct hlsl_ir_var *var, const struct source_location loc)
{
    struct hlsl_ir_load *load = d3dcompiler_alloc(sizeof(*load));

    if (!load)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    init_node(&load->node, HLSL_IR_LOAD, var->data_type, loc);
    load->src.var = var;
    return load;
}

static struct hlsl_ir_load *add_load(struct list *instrs, struct hlsl_ir_node *var_node, struct hlsl_ir_node *offset,
        struct hlsl_type *data_type, const struct source_location loc)
{
    struct hlsl_ir_node *add = NULL;
    struct hlsl_ir_load *load;
    struct hlsl_ir_var *var;

    if (var_node->type == HLSL_IR_LOAD)
    {
        const struct hlsl_deref *src = &load_from_node(var_node)->src;

        var = src->var;
        if (src->offset.node)
        {
            if (!(add = new_binary_expr(HLSL_IR_BINOP_ADD, src->offset.node, offset)))
                return NULL;
            list_add_tail(instrs, &add->entry);
            offset = add;
        }
    }
    else
    {
        struct hlsl_ir_assignment *assign;
        char name[27];

        sprintf(name, "<deref-%p>", var_node);
        if (!(var = new_synthetic_var(name, var_node->data_type, var_node->loc)))
            return NULL;

        TRACE("Synthesized variable %p for %s node.\n", var, debug_node_type(var_node->type));

        if (!(assign = new_simple_assignment(var, var_node)))
            return NULL;

        list_add_tail(instrs, &assign->node.entry);
    }

    if (!(load = d3dcompiler_alloc(sizeof(*load))))
        return NULL;
    init_node(&load->node, HLSL_IR_LOAD, data_type, loc);
    load->src.var = var;
    hlsl_src_from_node(&load->src.offset, offset);
    list_add_tail(instrs, &load->node.entry);
    return load;
}

static struct hlsl_ir_load *add_record_load(struct list *instrs, struct hlsl_ir_node *record,
        const struct hlsl_struct_field *field, const struct source_location loc)
{
    struct hlsl_ir_constant *c;

    if (!(c = new_uint_constant(field->reg_offset * 4, loc)))
        return NULL;
    list_add_tail(instrs, &c->node.entry);

    return add_load(instrs, record, &c->node, field->type, loc);
}

static struct hlsl_ir_load *add_array_load(struct list *instrs, struct hlsl_ir_node *array,
        struct hlsl_ir_node *index, const struct source_location loc)
{
    const struct hlsl_type *expr_type = array->data_type;
    struct hlsl_type *data_type;
    struct hlsl_ir_constant *c;
    struct hlsl_ir_node *mul;

    TRACE("Array load from type %s.\n", debug_hlsl_type(expr_type));

    if (expr_type->type == HLSL_CLASS_ARRAY)
    {
        data_type = expr_type->e.array.type;
    }
    else if (expr_type->type == HLSL_CLASS_MATRIX || expr_type->type == HLSL_CLASS_VECTOR)
    {
        /* This needs to be lowered now, while we still have type information. */
        FIXME("Index of matrix or vector type.\n");
        return NULL;
    }
    else
    {
        if (expr_type->type == HLSL_CLASS_SCALAR)
            hlsl_report_message(loc, HLSL_LEVEL_ERROR, "array-indexed expression is scalar");
        else
            hlsl_report_message(loc, HLSL_LEVEL_ERROR, "expression is not array-indexable");
        return NULL;
    }

    if (!(c = new_uint_constant(data_type->reg_size * 4, loc)))
        return NULL;
    list_add_tail(instrs, &c->node.entry);
    if (!(mul = new_binary_expr(HLSL_IR_BINOP_MUL, index, &c->node)))
        return NULL;
    list_add_tail(instrs, &mul->entry);
    index = mul;

    return add_load(instrs, array, index, data_type, loc);
}

static void struct_var_initializer(struct list *list, struct hlsl_ir_var *var,
        struct parse_initializer *initializer)
{
    struct hlsl_type *type = var->data_type;
    struct hlsl_struct_field *field;
    unsigned int i = 0;

    if (initializer_size(initializer) != components_count_type(type))
    {
        hlsl_report_message(var->loc, HLSL_LEVEL_ERROR, "structure initializer mismatch");
        free_parse_initializer(initializer);
        return;
    }

    list_move_tail(list, initializer->instrs);
    d3dcompiler_free(initializer->instrs);

    LIST_FOR_EACH_ENTRY(field, type->e.elements, struct hlsl_struct_field, entry)
    {
        struct hlsl_ir_node *node = initializer->args[i];
        struct hlsl_ir_assignment *assign;
        struct hlsl_ir_constant *c;

        if (i++ >= initializer->args_count)
            break;

        if (components_count_type(field->type) == components_count_type(node->data_type))
        {
            if (!(c = new_uint_constant(field->reg_offset * 4, node->loc)))
                break;
            list_add_tail(list, &c->node.entry);

            if (!(assign = new_assignment(var, &c->node, node, 0, node->loc)))
                break;
            list_add_tail(list, &assign->node.entry);
        }
        else
            FIXME("Initializing with \"mismatched\" fields is not supported yet.\n");
    }

    d3dcompiler_free(initializer->args);
}

static void free_parse_variable_def(struct parse_variable_def *v)
{
    free_parse_initializer(&v->initializer);
    d3dcompiler_free(v->name);
    d3dcompiler_free((void *)v->semantic);
    d3dcompiler_free(v->reg_reservation);
    d3dcompiler_free(v);
}

static struct list *declare_vars(struct hlsl_type *basic_type, DWORD modifiers, struct list *var_list)
{
    struct hlsl_type *type;
    struct parse_variable_def *v, *v_next;
    struct hlsl_ir_var *var;
    BOOL ret, local = TRUE;
    struct list *statements_list = d3dcompiler_alloc(sizeof(*statements_list));

    if (basic_type->type == HLSL_CLASS_MATRIX)
        assert(basic_type->modifiers & HLSL_MODIFIERS_MAJORITY_MASK);

    if (!statements_list)
    {
        ERR("Out of memory.\n");
        LIST_FOR_EACH_ENTRY_SAFE(v, v_next, var_list, struct parse_variable_def, entry)
            free_parse_variable_def(v);
        d3dcompiler_free(var_list);
        return NULL;
    }
    list_init(statements_list);

    if (!var_list)
        return statements_list;

    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, var_list, struct parse_variable_def, entry)
    {
        if (v->array_size)
            type = new_array_type(basic_type, v->array_size);
        else
            type = basic_type;

        if (!(var = new_var(v->name, type, v->loc, v->semantic, modifiers, v->reg_reservation)))
        {
            free_parse_variable_def(v);
            continue;
        }
        debug_dump_decl(type, modifiers, v->name, v->loc.line);

        if (hlsl_ctx.cur_scope == hlsl_ctx.globals)
        {
            var->modifiers |= HLSL_STORAGE_UNIFORM;
            local = FALSE;
        }

        if (type->modifiers & HLSL_MODIFIER_CONST && !(var->modifiers & HLSL_STORAGE_UNIFORM) && !v->initializer.args_count)
        {
            hlsl_report_message(v->loc, HLSL_LEVEL_ERROR, "const variable without initializer");
            free_declaration(var);
            d3dcompiler_free(v);
            continue;
        }

        ret = declare_variable(var, local);
        if (!ret)
        {
            free_declaration(var);
            d3dcompiler_free(v);
            continue;
        }
        TRACE("Declared variable %s.\n", var->name);

        if (v->initializer.args_count)
        {
            unsigned int size = initializer_size(&v->initializer);
            struct hlsl_ir_load *load;

            TRACE("Variable with initializer.\n");
            if (type->type <= HLSL_CLASS_LAST_NUMERIC
                    && type->dimx * type->dimy != size && size != 1)
            {
                if (size < type->dimx * type->dimy)
                {
                    hlsl_report_message(v->loc, HLSL_LEVEL_ERROR,
                            "'%s' initializer does not match", v->name);
                    free_parse_initializer(&v->initializer);
                    d3dcompiler_free(v);
                    continue;
                }
            }
            if ((type->type == HLSL_CLASS_STRUCT || type->type == HLSL_CLASS_ARRAY)
                    && components_count_type(type) != size)
            {
                hlsl_report_message(v->loc, HLSL_LEVEL_ERROR,
                        "'%s' initializer does not match", v->name);
                free_parse_initializer(&v->initializer);
                d3dcompiler_free(v);
                continue;
            }

            if (type->type == HLSL_CLASS_STRUCT)
            {
                struct_var_initializer(statements_list, var, &v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (type->type > HLSL_CLASS_LAST_NUMERIC)
            {
                FIXME("Initializers for non scalar/struct variables not supported yet.\n");
                free_parse_initializer(&v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (v->array_size > 0)
            {
                FIXME("Initializing arrays is not supported yet.\n");
                free_parse_initializer(&v->initializer);
                d3dcompiler_free(v);
                continue;
            }
            if (v->initializer.args_count > 1)
            {
                FIXME("Complex initializers are not supported yet.\n");
                free_parse_initializer(&v->initializer);
                d3dcompiler_free(v);
                continue;
            }

            load = new_var_load(var, var->loc);
            list_add_tail(v->initializer.instrs, &load->node.entry);
            add_assignment(v->initializer.instrs, &load->node, ASSIGN_OP_ASSIGN, v->initializer.args[0]);
            d3dcompiler_free(v->initializer.args);

            if (modifiers & HLSL_STORAGE_STATIC)
                list_move_tail(&hlsl_ctx.static_initializers, v->initializer.instrs);
            else
                list_move_tail(statements_list, v->initializer.instrs);
            d3dcompiler_free(v->initializer.instrs);
        }
        d3dcompiler_free(v);
    }
    d3dcompiler_free(var_list);
    return statements_list;
}

static BOOL add_struct_field(struct list *fields, struct hlsl_struct_field *field)
{
    struct hlsl_struct_field *f;

    LIST_FOR_EACH_ENTRY(f, fields, struct hlsl_struct_field, entry)
    {
        if (!strcmp(f->name, field->name))
            return FALSE;
    }
    list_add_tail(fields, &field->entry);
    return TRUE;
}

BOOL is_row_major(const struct hlsl_type *type)
{
    /* Default to column-major if the majority isn't explicitly set, which can
     * happen for anonymous nodes. */
    return !!(type->modifiers & HLSL_MODIFIER_ROW_MAJOR);
}

static struct hlsl_type *apply_type_modifiers(struct hlsl_type *type,
        unsigned int *modifiers, struct source_location loc)
{
    unsigned int default_majority = 0;
    struct hlsl_type *new_type;

    /* This function is only used for declarations (i.e. variables and struct
     * fields), which should inherit the matrix majority. We only explicitly set
     * the default majority for declarations—typedefs depend on this—but we
     * want to always set it, so that an hlsl_type object is never used to
     * represent two different majorities (and thus can be used to store its
     * register size, etc.) */
    if (!(*modifiers & HLSL_MODIFIERS_MAJORITY_MASK)
            && !(type->modifiers & HLSL_MODIFIERS_MAJORITY_MASK)
            && type->type == HLSL_CLASS_MATRIX)
    {
        if (hlsl_ctx.matrix_majority == HLSL_COLUMN_MAJOR)
            default_majority = HLSL_MODIFIER_COLUMN_MAJOR;
        else
            default_majority = HLSL_MODIFIER_ROW_MAJOR;
    }

    if (!default_majority && !(*modifiers & HLSL_TYPE_MODIFIERS_MASK))
        return type;

    if (!(new_type = clone_hlsl_type(type, default_majority)))
        return NULL;

    new_type->modifiers = add_modifiers(new_type->modifiers, *modifiers, loc);
    *modifiers &= ~HLSL_TYPE_MODIFIERS_MASK;

    if (new_type->type == HLSL_CLASS_MATRIX)
        new_type->reg_size = is_row_major(new_type) ? new_type->dimy : new_type->dimx;
    return new_type;
}

static struct list *gen_struct_fields(struct hlsl_type *type, DWORD modifiers, struct list *fields)
{
    struct parse_variable_def *v, *v_next;
    struct hlsl_struct_field *field;
    struct list *list;

    if (type->type == HLSL_CLASS_MATRIX)
        assert(type->modifiers & HLSL_MODIFIERS_MAJORITY_MASK);

    list = d3dcompiler_alloc(sizeof(*list));
    if (!list)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    list_init(list);
    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, fields, struct parse_variable_def, entry)
    {
        debug_dump_decl(type, 0, v->name, v->loc.line);
        field = d3dcompiler_alloc(sizeof(*field));
        if (!field)
        {
            ERR("Out of memory.\n");
            d3dcompiler_free(v);
            return list;
        }
        if (v->array_size)
            field->type = new_array_type(type, v->array_size);
        else
            field->type = type;
        field->name = v->name;
        field->modifiers = modifiers;
        field->semantic = v->semantic;
        if (v->initializer.args_count)
        {
            hlsl_report_message(v->loc, HLSL_LEVEL_ERROR, "struct field with an initializer.\n");
            free_parse_initializer(&v->initializer);
        }
        list_add_tail(list, &field->entry);
        d3dcompiler_free(v);
    }
    d3dcompiler_free(fields);
    return list;
}

static DWORD get_array_size(const struct hlsl_type *type)
{
    if (type->type == HLSL_CLASS_ARRAY)
        return get_array_size(type->e.array.type) * type->e.array.elements_count;
    return 1;
}

static struct hlsl_type *new_struct_type(const char *name, struct list *fields)
{
    struct hlsl_type *type = d3dcompiler_alloc(sizeof(*type));
    struct hlsl_struct_field *field;
    unsigned int reg_size = 0;

    if (!type)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    type->type = HLSL_CLASS_STRUCT;
    type->base_type = HLSL_TYPE_VOID;
    type->name = name;
    type->dimx = 0;
    type->dimy = 1;
    type->e.elements = fields;

    LIST_FOR_EACH_ENTRY(field, fields, struct hlsl_struct_field, entry)
    {
        field->reg_offset = reg_size;
        reg_size += field->type->reg_size;
        type->dimx += field->type->dimx * field->type->dimy * get_array_size(field->type);
    }
    type->reg_size = reg_size;

    list_add_tail(&hlsl_ctx.types, &type->entry);

    return type;
}

static BOOL add_typedef(DWORD modifiers, struct hlsl_type *orig_type, struct list *list)
{
    BOOL ret;
    struct hlsl_type *type;
    struct parse_variable_def *v, *v_next;

    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, list, struct parse_variable_def, entry)
    {
        if (v->array_size)
            type = new_array_type(orig_type, v->array_size);
        else
            type = clone_hlsl_type(orig_type, 0);
        if (!type)
        {
            ERR("Out of memory\n");
            return FALSE;
        }
        d3dcompiler_free((void *)type->name);
        type->name = v->name;
        type->modifiers |= modifiers;

        if (type->type != HLSL_CLASS_MATRIX)
            check_invalid_matrix_modifiers(type->modifiers, v->loc);
        else
            type->reg_size = is_row_major(type) ? type->dimy : type->dimx;

        if ((type->modifiers & HLSL_MODIFIER_COLUMN_MAJOR)
                && (type->modifiers & HLSL_MODIFIER_ROW_MAJOR))
            hlsl_report_message(v->loc, HLSL_LEVEL_ERROR, "more than one matrix majority keyword");

        ret = add_type_to_scope(hlsl_ctx.cur_scope, type);
        if (!ret)
        {
            hlsl_report_message(v->loc, HLSL_LEVEL_ERROR,
                    "redefinition of custom type '%s'", v->name);
        }
        d3dcompiler_free(v);
    }
    d3dcompiler_free(list);
    return TRUE;
}

static BOOL add_func_parameter(struct list *list, struct parse_parameter *param, const struct source_location loc)
{
    struct hlsl_ir_var *var;

    if (param->type->type == HLSL_CLASS_MATRIX)
        assert(param->type->modifiers & HLSL_MODIFIERS_MAJORITY_MASK);

    if (!(var = new_var(param->name, param->type, loc, param->semantic, param->modifiers, param->reg_reservation)))
        return FALSE;

    if (!add_declaration(hlsl_ctx.cur_scope, var, FALSE))
    {
        free_declaration(var);
        return FALSE;
    }
    list_add_tail(list, &var->param_entry);
    return TRUE;
}

static struct reg_reservation *parse_reg_reservation(const char *reg_string)
{
    struct reg_reservation *reg_res;
    enum bwritershader_param_register_type type;
    DWORD regnum = 0;

    switch (reg_string[0])
    {
        case 'c':
            type = BWRITERSPR_CONST;
            break;
        case 'i':
            type = BWRITERSPR_CONSTINT;
            break;
        case 'b':
            type = BWRITERSPR_CONSTBOOL;
            break;
        case 's':
            type = BWRITERSPR_SAMPLER;
            break;
        default:
            FIXME("Unsupported register type.\n");
            return NULL;
     }

    if (!sscanf(reg_string + 1, "%u", &regnum))
    {
        FIXME("Unsupported register reservation syntax.\n");
        return NULL;
    }

    reg_res = d3dcompiler_alloc(sizeof(*reg_res));
    if (!reg_res)
    {
        ERR("Out of memory.\n");
        return NULL;
    }
    reg_res->type = type;
    reg_res->regnum = regnum;
    return reg_res;
}

static const struct hlsl_ir_function_decl *get_overloaded_func(struct wine_rb_tree *funcs, char *name,
        struct list *params, BOOL exact_signature)
{
    struct hlsl_ir_function *func;
    struct wine_rb_entry *entry;

    entry = wine_rb_get(funcs, name);
    if (entry)
    {
        func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function, entry);

        entry = wine_rb_get(&func->overloads, params);
        if (!entry)
        {
            if (!exact_signature)
                FIXME("No exact match, search for a compatible overloaded function (if any).\n");
            return NULL;
        }
        return WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function_decl, entry);
    }
    return NULL;
}

static struct hlsl_ir_function_decl *get_func_entry(const char *name)
{
    struct hlsl_ir_function_decl *decl;
    struct hlsl_ir_function *func;
    struct wine_rb_entry *entry;

    if ((entry = wine_rb_get(&hlsl_ctx.functions, name)))
    {
        func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function, entry);
        WINE_RB_FOR_EACH_ENTRY(decl, &func->overloads, struct hlsl_ir_function_decl, entry)
            return decl;
    }

    return NULL;
}

static struct list *append_unop(struct list *list, struct hlsl_ir_node *node)
{
    list_add_tail(list, &node->entry);
    return list;
}

static struct list *add_binary_expr(struct list *list1, struct list *list2,
        enum hlsl_ir_expr_op op, struct source_location loc)
{
    struct hlsl_ir_node *args[3] = {node_from_list(list1), node_from_list(list2)};
    list_move_tail(list1, list2);
    d3dcompiler_free(list2);
    add_expr(list1, op, args, &loc);
    return list1;
}

static struct list *make_list(struct hlsl_ir_node *node)
{
    struct list *list;

    if (!(list = d3dcompiler_alloc(sizeof(*list))))
    {
        ERR("Out of memory.\n");
        free_instr(node);
        return NULL;
    }
    list_init(list);
    list_add_tail(list, &node->entry);
    return list;
}

static unsigned int evaluate_array_dimension(struct hlsl_ir_node *node)
{
    if (node->data_type->type != HLSL_CLASS_SCALAR)
        return 0;

    switch (node->type)
    {
    case HLSL_IR_CONSTANT:
    {
        struct hlsl_ir_constant *constant = constant_from_node(node);

        switch (constant->node.data_type->base_type)
        {
        case HLSL_TYPE_UINT:
            return constant->value.u[0];
        case HLSL_TYPE_INT:
            return constant->value.i[0];
        case HLSL_TYPE_FLOAT:
            return constant->value.f[0];
        case HLSL_TYPE_DOUBLE:
            return constant->value.d[0];
        case HLSL_TYPE_BOOL:
            return constant->value.b[0];
        default:
            WARN("Invalid type %s.\n", debug_base_type(constant->node.data_type));
            return 0;
        }
    }
    case HLSL_IR_EXPR:
    case HLSL_IR_LOAD:
    case HLSL_IR_SWIZZLE:
        FIXME("Unhandled type %s.\n", debug_node_type(node->type));
        return 0;
    case HLSL_IR_ASSIGNMENT:
    default:
        WARN("Invalid node type %s.\n", debug_node_type(node->type));
        return 0;
    }
}

static struct hlsl_ir_function_decl *new_func_decl(struct hlsl_type *return_type,
        struct list *parameters, const char *semantic, struct source_location loc)
{
    struct hlsl_ir_function_decl *decl;

    if (!(decl = d3dcompiler_alloc(sizeof(*decl))))
        return NULL;
    decl->return_type = return_type;
    decl->parameters = parameters;
    decl->semantic = semantic;
    decl->loc = loc;

    if (!type_is_void(return_type))
    {
        struct hlsl_ir_var *return_var;
        char name[28];

        sprintf(name, "<retval-%p>", decl);
        if (!(return_var = new_synthetic_var(name, return_type, loc)))
        {
            d3dcompiler_free(decl);
            return NULL;
        }
        decl->return_var = return_var;
    }

    return decl;
}


#line 1377 "dlls/d3dcompiler_35/hlsl.tab.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif


/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int hlsl_debug;
#endif

/* Token kinds.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    YYEMPTY = -2,
    YYEOF = 0,                     /* "end of file"  */
    YYerror = 256,                 /* error  */
    YYUNDEF = 257,                 /* "invalid token"  */
    KW_BLENDSTATE = 258,           /* KW_BLENDSTATE  */
    KW_BREAK = 259,                /* KW_BREAK  */
    KW_BUFFER = 260,               /* KW_BUFFER  */
    KW_CBUFFER = 261,              /* KW_CBUFFER  */
    KW_COLUMN_MAJOR = 262,         /* KW_COLUMN_MAJOR  */
    KW_COMPILE = 263,              /* KW_COMPILE  */
    KW_CONST = 264,                /* KW_CONST  */
    KW_CONTINUE = 265,             /* KW_CONTINUE  */
    KW_DEPTHSTENCILSTATE = 266,    /* KW_DEPTHSTENCILSTATE  */
    KW_DEPTHSTENCILVIEW = 267,     /* KW_DEPTHSTENCILVIEW  */
    KW_DISCARD = 268,              /* KW_DISCARD  */
    KW_DO = 269,                   /* KW_DO  */
    KW_DOUBLE = 270,               /* KW_DOUBLE  */
    KW_ELSE = 271,                 /* KW_ELSE  */
    KW_EXTERN = 272,               /* KW_EXTERN  */
    KW_FALSE = 273,                /* KW_FALSE  */
    KW_FOR = 274,                  /* KW_FOR  */
    KW_GEOMETRYSHADER = 275,       /* KW_GEOMETRYSHADER  */
    KW_GROUPSHARED = 276,          /* KW_GROUPSHARED  */
    KW_IF = 277,                   /* KW_IF  */
    KW_IN = 278,                   /* KW_IN  */
    KW_INLINE = 279,               /* KW_INLINE  */
    KW_INOUT = 280,                /* KW_INOUT  */
    KW_MATRIX = 281,               /* KW_MATRIX  */
    KW_NAMESPACE = 282,            /* KW_NAMESPACE  */
    KW_NOINTERPOLATION = 283,      /* KW_NOINTERPOLATION  */
    KW_OUT = 284,                  /* KW_OUT  */
    KW_PASS = 285,                 /* KW_PASS  */
    KW_PIXELSHADER = 286,          /* KW_PIXELSHADER  */
    KW_PRECISE = 287,              /* KW_PRECISE  */
    KW_RASTERIZERSTATE = 288,      /* KW_RASTERIZERSTATE  */
    KW_RENDERTARGETVIEW = 289,     /* KW_RENDERTARGETVIEW  */
    KW_RETURN = 290,               /* KW_RETURN  */
    KW_REGISTER = 291,             /* KW_REGISTER  */
    KW_ROW_MAJOR = 292,            /* KW_ROW_MAJOR  */
    KW_SAMPLER = 293,              /* KW_SAMPLER  */
    KW_SAMPLER1D = 294,            /* KW_SAMPLER1D  */
    KW_SAMPLER2D = 295,            /* KW_SAMPLER2D  */
    KW_SAMPLER3D = 296,            /* KW_SAMPLER3D  */
    KW_SAMPLERCUBE = 297,          /* KW_SAMPLERCUBE  */
    KW_SAMPLER_STATE = 298,        /* KW_SAMPLER_STATE  */
    KW_SAMPLERCOMPARISONSTATE = 299, /* KW_SAMPLERCOMPARISONSTATE  */
    KW_SHARED = 300,               /* KW_SHARED  */
    KW_STATEBLOCK = 301,           /* KW_STATEBLOCK  */
    KW_STATEBLOCK_STATE = 302,     /* KW_STATEBLOCK_STATE  */
    KW_STATIC = 303,               /* KW_STATIC  */
    KW_STRING = 304,               /* KW_STRING  */
    KW_STRUCT = 305,               /* KW_STRUCT  */
    KW_SWITCH = 306,               /* KW_SWITCH  */
    KW_TBUFFER = 307,              /* KW_TBUFFER  */
    KW_TECHNIQUE = 308,            /* KW_TECHNIQUE  */
    KW_TECHNIQUE10 = 309,          /* KW_TECHNIQUE10  */
    KW_TEXTURE = 310,              /* KW_TEXTURE  */
    KW_TEXTURE1D = 311,            /* KW_TEXTURE1D  */
    KW_TEXTURE1DARRAY = 312,       /* KW_TEXTURE1DARRAY  */
    KW_TEXTURE2D = 313,            /* KW_TEXTURE2D  */
    KW_TEXTURE2DARRAY = 314,       /* KW_TEXTURE2DARRAY  */
    KW_TEXTURE2DMS = 315,          /* KW_TEXTURE2DMS  */
    KW_TEXTURE2DMSARRAY = 316,     /* KW_TEXTURE2DMSARRAY  */
    KW_TEXTURE3D = 317,            /* KW_TEXTURE3D  */
    KW_TEXTURE3DARRAY = 318,       /* KW_TEXTURE3DARRAY  */
    KW_TEXTURECUBE = 319,          /* KW_TEXTURECUBE  */
    KW_TRUE = 320,                 /* KW_TRUE  */
    KW_TYPEDEF = 321,              /* KW_TYPEDEF  */
    KW_UNIFORM = 322,              /* KW_UNIFORM  */
    KW_VECTOR = 323,               /* KW_VECTOR  */
    KW_VERTEXSHADER = 324,         /* KW_VERTEXSHADER  */
    KW_VOID = 325,                 /* KW_VOID  */
    KW_VOLATILE = 326,             /* KW_VOLATILE  */
    KW_WHILE = 327,                /* KW_WHILE  */
    OP_INC = 328,                  /* OP_INC  */
    OP_DEC = 329,                  /* OP_DEC  */
    OP_AND = 330,                  /* OP_AND  */
    OP_OR = 331,                   /* OP_OR  */
    OP_EQ = 332,                   /* OP_EQ  */
    OP_LEFTSHIFT = 333,            /* OP_LEFTSHIFT  */
    OP_LEFTSHIFTASSIGN = 334,      /* OP_LEFTSHIFTASSIGN  */
    OP_RIGHTSHIFT = 335,           /* OP_RIGHTSHIFT  */
    OP_RIGHTSHIFTASSIGN = 336,     /* OP_RIGHTSHIFTASSIGN  */
    OP_ELLIPSIS = 337,             /* OP_ELLIPSIS  */
    OP_LE = 338,                   /* OP_LE  */
    OP_GE = 339,                   /* OP_GE  */
    OP_NE = 340,                   /* OP_NE  */
    OP_ADDASSIGN = 341,            /* OP_ADDASSIGN  */
    OP_SUBASSIGN = 342,            /* OP_SUBASSIGN  */
    OP_MULASSIGN = 343,            /* OP_MULASSIGN  */
    OP_DIVASSIGN = 344,            /* OP_DIVASSIGN  */
    OP_MODASSIGN = 345,            /* OP_MODASSIGN  */
    OP_ANDASSIGN = 346,            /* OP_ANDASSIGN  */
    OP_ORASSIGN = 347,             /* OP_ORASSIGN  */
    OP_XORASSIGN = 348,            /* OP_XORASSIGN  */
    OP_UNKNOWN1 = 349,             /* OP_UNKNOWN1  */
    OP_UNKNOWN2 = 350,             /* OP_UNKNOWN2  */
    OP_UNKNOWN3 = 351,             /* OP_UNKNOWN3  */
    OP_UNKNOWN4 = 352,             /* OP_UNKNOWN4  */
    PRE_LINE = 353,                /* PRE_LINE  */
    VAR_IDENTIFIER = 354,          /* VAR_IDENTIFIER  */
    TYPE_IDENTIFIER = 355,         /* TYPE_IDENTIFIER  */
    NEW_IDENTIFIER = 356,          /* NEW_IDENTIFIER  */
    STRING = 357,                  /* STRING  */
    C_FLOAT = 358,                 /* C_FLOAT  */
    C_INTEGER = 359                /* C_INTEGER  */
  };
  typedef enum yytokentype yytoken_kind_t;
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
union YYSTYPE
{
#line 1324 "dlls/d3dcompiler_43/hlsl.y"

    struct hlsl_type *type;
    INT intval;
    FLOAT floatval;
    BOOL boolval;
    char *name;
    DWORD modifiers;
    struct hlsl_ir_node *instr;
    struct list *list;
    struct parse_function function;
    struct parse_parameter parameter;
    struct parse_initializer initializer;
    struct parse_variable_def *variable_def;
    struct parse_if_body if_body;
    enum parse_unary_op unary_op;
    enum parse_assign_op assign_op;
    struct reg_reservation *reg_reservation;
    struct parse_colon_attribute colon_attribute;

#line 1548 "dlls/d3dcompiler_35/hlsl.tab.c"

};
typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


extern YYSTYPE hlsl_lval;
extern YYLTYPE hlsl_lloc;
int hlsl_parse (void);


/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_KW_BLENDSTATE = 3,              /* KW_BLENDSTATE  */
  YYSYMBOL_KW_BREAK = 4,                   /* KW_BREAK  */
  YYSYMBOL_KW_BUFFER = 5,                  /* KW_BUFFER  */
  YYSYMBOL_KW_CBUFFER = 6,                 /* KW_CBUFFER  */
  YYSYMBOL_KW_COLUMN_MAJOR = 7,            /* KW_COLUMN_MAJOR  */
  YYSYMBOL_KW_COMPILE = 8,                 /* KW_COMPILE  */
  YYSYMBOL_KW_CONST = 9,                   /* KW_CONST  */
  YYSYMBOL_KW_CONTINUE = 10,               /* KW_CONTINUE  */
  YYSYMBOL_KW_DEPTHSTENCILSTATE = 11,      /* KW_DEPTHSTENCILSTATE  */
  YYSYMBOL_KW_DEPTHSTENCILVIEW = 12,       /* KW_DEPTHSTENCILVIEW  */
  YYSYMBOL_KW_DISCARD = 13,                /* KW_DISCARD  */
  YYSYMBOL_KW_DO = 14,                     /* KW_DO  */
  YYSYMBOL_KW_DOUBLE = 15,                 /* KW_DOUBLE  */
  YYSYMBOL_KW_ELSE = 16,                   /* KW_ELSE  */
  YYSYMBOL_KW_EXTERN = 17,                 /* KW_EXTERN  */
  YYSYMBOL_KW_FALSE = 18,                  /* KW_FALSE  */
  YYSYMBOL_KW_FOR = 19,                    /* KW_FOR  */
  YYSYMBOL_KW_GEOMETRYSHADER = 20,         /* KW_GEOMETRYSHADER  */
  YYSYMBOL_KW_GROUPSHARED = 21,            /* KW_GROUPSHARED  */
  YYSYMBOL_KW_IF = 22,                     /* KW_IF  */
  YYSYMBOL_KW_IN = 23,                     /* KW_IN  */
  YYSYMBOL_KW_INLINE = 24,                 /* KW_INLINE  */
  YYSYMBOL_KW_INOUT = 25,                  /* KW_INOUT  */
  YYSYMBOL_KW_MATRIX = 26,                 /* KW_MATRIX  */
  YYSYMBOL_KW_NAMESPACE = 27,              /* KW_NAMESPACE  */
  YYSYMBOL_KW_NOINTERPOLATION = 28,        /* KW_NOINTERPOLATION  */
  YYSYMBOL_KW_OUT = 29,                    /* KW_OUT  */
  YYSYMBOL_KW_PASS = 30,                   /* KW_PASS  */
  YYSYMBOL_KW_PIXELSHADER = 31,            /* KW_PIXELSHADER  */
  YYSYMBOL_KW_PRECISE = 32,                /* KW_PRECISE  */
  YYSYMBOL_KW_RASTERIZERSTATE = 33,        /* KW_RASTERIZERSTATE  */
  YYSYMBOL_KW_RENDERTARGETVIEW = 34,       /* KW_RENDERTARGETVIEW  */
  YYSYMBOL_KW_RETURN = 35,                 /* KW_RETURN  */
  YYSYMBOL_KW_REGISTER = 36,               /* KW_REGISTER  */
  YYSYMBOL_KW_ROW_MAJOR = 37,              /* KW_ROW_MAJOR  */
  YYSYMBOL_KW_SAMPLER = 38,                /* KW_SAMPLER  */
  YYSYMBOL_KW_SAMPLER1D = 39,              /* KW_SAMPLER1D  */
  YYSYMBOL_KW_SAMPLER2D = 40,              /* KW_SAMPLER2D  */
  YYSYMBOL_KW_SAMPLER3D = 41,              /* KW_SAMPLER3D  */
  YYSYMBOL_KW_SAMPLERCUBE = 42,            /* KW_SAMPLERCUBE  */
  YYSYMBOL_KW_SAMPLER_STATE = 43,          /* KW_SAMPLER_STATE  */
  YYSYMBOL_KW_SAMPLERCOMPARISONSTATE = 44, /* KW_SAMPLERCOMPARISONSTATE  */
  YYSYMBOL_KW_SHARED = 45,                 /* KW_SHARED  */
  YYSYMBOL_KW_STATEBLOCK = 46,             /* KW_STATEBLOCK  */
  YYSYMBOL_KW_STATEBLOCK_STATE = 47,       /* KW_STATEBLOCK_STATE  */
  YYSYMBOL_KW_STATIC = 48,                 /* KW_STATIC  */
  YYSYMBOL_KW_STRING = 49,                 /* KW_STRING  */
  YYSYMBOL_KW_STRUCT = 50,                 /* KW_STRUCT  */
  YYSYMBOL_KW_SWITCH = 51,                 /* KW_SWITCH  */
  YYSYMBOL_KW_TBUFFER = 52,                /* KW_TBUFFER  */
  YYSYMBOL_KW_TECHNIQUE = 53,              /* KW_TECHNIQUE  */
  YYSYMBOL_KW_TECHNIQUE10 = 54,            /* KW_TECHNIQUE10  */
  YYSYMBOL_KW_TEXTURE = 55,                /* KW_TEXTURE  */
  YYSYMBOL_KW_TEXTURE1D = 56,              /* KW_TEXTURE1D  */
  YYSYMBOL_KW_TEXTURE1DARRAY = 57,         /* KW_TEXTURE1DARRAY  */
  YYSYMBOL_KW_TEXTURE2D = 58,              /* KW_TEXTURE2D  */
  YYSYMBOL_KW_TEXTURE2DARRAY = 59,         /* KW_TEXTURE2DARRAY  */
  YYSYMBOL_KW_TEXTURE2DMS = 60,            /* KW_TEXTURE2DMS  */
  YYSYMBOL_KW_TEXTURE2DMSARRAY = 61,       /* KW_TEXTURE2DMSARRAY  */
  YYSYMBOL_KW_TEXTURE3D = 62,              /* KW_TEXTURE3D  */
  YYSYMBOL_KW_TEXTURE3DARRAY = 63,         /* KW_TEXTURE3DARRAY  */
  YYSYMBOL_KW_TEXTURECUBE = 64,            /* KW_TEXTURECUBE  */
  YYSYMBOL_KW_TRUE = 65,                   /* KW_TRUE  */
  YYSYMBOL_KW_TYPEDEF = 66,                /* KW_TYPEDEF  */
  YYSYMBOL_KW_UNIFORM = 67,                /* KW_UNIFORM  */
  YYSYMBOL_KW_VECTOR = 68,                 /* KW_VECTOR  */
  YYSYMBOL_KW_VERTEXSHADER = 69,           /* KW_VERTEXSHADER  */
  YYSYMBOL_KW_VOID = 70,                   /* KW_VOID  */
  YYSYMBOL_KW_VOLATILE = 71,               /* KW_VOLATILE  */
  YYSYMBOL_KW_WHILE = 72,                  /* KW_WHILE  */
  YYSYMBOL_OP_INC = 73,                    /* OP_INC  */
  YYSYMBOL_OP_DEC = 74,                    /* OP_DEC  */
  YYSYMBOL_OP_AND = 75,                    /* OP_AND  */
  YYSYMBOL_OP_OR = 76,                     /* OP_OR  */
  YYSYMBOL_OP_EQ = 77,                     /* OP_EQ  */
  YYSYMBOL_OP_LEFTSHIFT = 78,              /* OP_LEFTSHIFT  */
  YYSYMBOL_OP_LEFTSHIFTASSIGN = 79,        /* OP_LEFTSHIFTASSIGN  */
  YYSYMBOL_OP_RIGHTSHIFT = 80,             /* OP_RIGHTSHIFT  */
  YYSYMBOL_OP_RIGHTSHIFTASSIGN = 81,       /* OP_RIGHTSHIFTASSIGN  */
  YYSYMBOL_OP_ELLIPSIS = 82,               /* OP_ELLIPSIS  */
  YYSYMBOL_OP_LE = 83,                     /* OP_LE  */
  YYSYMBOL_OP_GE = 84,                     /* OP_GE  */
  YYSYMBOL_OP_NE = 85,                     /* OP_NE  */
  YYSYMBOL_OP_ADDASSIGN = 86,              /* OP_ADDASSIGN  */
  YYSYMBOL_OP_SUBASSIGN = 87,              /* OP_SUBASSIGN  */
  YYSYMBOL_OP_MULASSIGN = 88,              /* OP_MULASSIGN  */
  YYSYMBOL_OP_DIVASSIGN = 89,              /* OP_DIVASSIGN  */
  YYSYMBOL_OP_MODASSIGN = 90,              /* OP_MODASSIGN  */
  YYSYMBOL_OP_ANDASSIGN = 91,              /* OP_ANDASSIGN  */
  YYSYMBOL_OP_ORASSIGN = 92,               /* OP_ORASSIGN  */
  YYSYMBOL_OP_XORASSIGN = 93,              /* OP_XORASSIGN  */
  YYSYMBOL_OP_UNKNOWN1 = 94,               /* OP_UNKNOWN1  */
  YYSYMBOL_OP_UNKNOWN2 = 95,               /* OP_UNKNOWN2  */
  YYSYMBOL_OP_UNKNOWN3 = 96,               /* OP_UNKNOWN3  */
  YYSYMBOL_OP_UNKNOWN4 = 97,               /* OP_UNKNOWN4  */
  YYSYMBOL_PRE_LINE = 98,                  /* PRE_LINE  */
  YYSYMBOL_VAR_IDENTIFIER = 99,            /* VAR_IDENTIFIER  */
  YYSYMBOL_TYPE_IDENTIFIER = 100,          /* TYPE_IDENTIFIER  */
  YYSYMBOL_NEW_IDENTIFIER = 101,           /* NEW_IDENTIFIER  */
  YYSYMBOL_STRING = 102,                   /* STRING  */
  YYSYMBOL_C_FLOAT = 103,                  /* C_FLOAT  */
  YYSYMBOL_C_INTEGER = 104,                /* C_INTEGER  */
  YYSYMBOL_105_ = 105,                     /* ';'  */
  YYSYMBOL_106_ = 106,                     /* '{'  */
  YYSYMBOL_107_ = 107,                     /* '}'  */
  YYSYMBOL_108_ = 108,                     /* '('  */
  YYSYMBOL_109_ = 109,                     /* ')'  */
  YYSYMBOL_110_ = 110,                     /* ':'  */
  YYSYMBOL_111_ = 111,                     /* ','  */
  YYSYMBOL_112_ = 112,                     /* '<'  */
  YYSYMBOL_113_ = 113,                     /* '>'  */
  YYSYMBOL_114_ = 114,                     /* '='  */
  YYSYMBOL_115_ = 115,                     /* '['  */
  YYSYMBOL_116_ = 116,                     /* ']'  */
  YYSYMBOL_117_ = 117,                     /* '.'  */
  YYSYMBOL_118_ = 118,                     /* '+'  */
  YYSYMBOL_119_ = 119,                     /* '-'  */
  YYSYMBOL_120_ = 120,                     /* '!'  */
  YYSYMBOL_121_ = 121,                     /* '~'  */
  YYSYMBOL_122_ = 122,                     /* '*'  */
  YYSYMBOL_123_ = 123,                     /* '/'  */
  YYSYMBOL_124_ = 124,                     /* '%'  */
  YYSYMBOL_125_ = 125,                     /* '&'  */
  YYSYMBOL_126_ = 126,                     /* '^'  */
  YYSYMBOL_127_ = 127,                     /* '|'  */
  YYSYMBOL_128_ = 128,                     /* '?'  */
  YYSYMBOL_YYACCEPT = 129,                 /* $accept  */
  YYSYMBOL_hlsl_prog = 130,                /* hlsl_prog  */
  YYSYMBOL_preproc_directive = 131,        /* preproc_directive  */
  YYSYMBOL_struct_declaration = 132,       /* struct_declaration  */
  YYSYMBOL_struct_spec = 133,              /* struct_spec  */
  YYSYMBOL_named_struct_spec = 134,        /* named_struct_spec  */
  YYSYMBOL_unnamed_struct_spec = 135,      /* unnamed_struct_spec  */
  YYSYMBOL_any_identifier = 136,           /* any_identifier  */
  YYSYMBOL_fields_list = 137,              /* fields_list  */
  YYSYMBOL_field_type = 138,               /* field_type  */
  YYSYMBOL_field = 139,                    /* field  */
  YYSYMBOL_func_declaration = 140,         /* func_declaration  */
  YYSYMBOL_func_prototype = 141,           /* func_prototype  */
  YYSYMBOL_compound_statement = 142,       /* compound_statement  */
  YYSYMBOL_scope_start = 143,              /* scope_start  */
  YYSYMBOL_var_identifier = 144,           /* var_identifier  */
  YYSYMBOL_colon_attribute = 145,          /* colon_attribute  */
  YYSYMBOL_semantic = 146,                 /* semantic  */
  YYSYMBOL_register_opt = 147,             /* register_opt  */
  YYSYMBOL_parameters = 148,               /* parameters  */
  YYSYMBOL_param_list = 149,               /* param_list  */
  YYSYMBOL_parameter = 150,                /* parameter  */
  YYSYMBOL_input_mods = 151,               /* input_mods  */
  YYSYMBOL_input_mod = 152,                /* input_mod  */
  YYSYMBOL_type = 153,                     /* type  */
  YYSYMBOL_base_type = 154,                /* base_type  */
  YYSYMBOL_declaration_statement = 155,    /* declaration_statement  */
  YYSYMBOL_typedef_type = 156,             /* typedef_type  */
  YYSYMBOL_typedef = 157,                  /* typedef  */
  YYSYMBOL_type_specs = 158,               /* type_specs  */
  YYSYMBOL_type_spec = 159,                /* type_spec  */
  YYSYMBOL_declaration = 160,              /* declaration  */
  YYSYMBOL_variables_def_optional = 161,   /* variables_def_optional  */
  YYSYMBOL_variables_def = 162,            /* variables_def  */
  YYSYMBOL_variable_def = 163,             /* variable_def  */
  YYSYMBOL_array = 164,                    /* array  */
  YYSYMBOL_var_modifiers = 165,            /* var_modifiers  */
  YYSYMBOL_complex_initializer = 166,      /* complex_initializer  */
  YYSYMBOL_initializer_expr = 167,         /* initializer_expr  */
  YYSYMBOL_initializer_expr_list = 168,    /* initializer_expr_list  */
  YYSYMBOL_boolean = 169,                  /* boolean  */
  YYSYMBOL_statement_list = 170,           /* statement_list  */
  YYSYMBOL_statement = 171,                /* statement  */
  YYSYMBOL_jump_statement = 172,           /* jump_statement  */
  YYSYMBOL_selection_statement = 173,      /* selection_statement  */
  YYSYMBOL_if_body = 174,                  /* if_body  */
  YYSYMBOL_loop_statement = 175,           /* loop_statement  */
  YYSYMBOL_expr_statement = 176,           /* expr_statement  */
  YYSYMBOL_primary_expr = 177,             /* primary_expr  */
  YYSYMBOL_postfix_expr = 178,             /* postfix_expr  */
  YYSYMBOL_unary_expr = 179,               /* unary_expr  */
  YYSYMBOL_unary_op = 180,                 /* unary_op  */
  YYSYMBOL_mul_expr = 181,                 /* mul_expr  */
  YYSYMBOL_add_expr = 182,                 /* add_expr  */
  YYSYMBOL_shift_expr = 183,               /* shift_expr  */
  YYSYMBOL_relational_expr = 184,          /* relational_expr  */
  YYSYMBOL_equality_expr = 185,            /* equality_expr  */
  YYSYMBOL_bitand_expr = 186,              /* bitand_expr  */
  YYSYMBOL_bitxor_expr = 187,              /* bitxor_expr  */
  YYSYMBOL_bitor_expr = 188,               /* bitor_expr  */
  YYSYMBOL_logicand_expr = 189,            /* logicand_expr  */
  YYSYMBOL_logicor_expr = 190,             /* logicor_expr  */
  YYSYMBOL_conditional_expr = 191,         /* conditional_expr  */
  YYSYMBOL_assignment_expr = 192,          /* assignment_expr  */
  YYSYMBOL_assign_op = 193,                /* assign_op  */
  YYSYMBOL_expr = 194                      /* expr  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   871

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  66
/* YYNRULES -- Number of rules.  */
#define YYNRULES  177
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  319

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   359


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   120,     2,     2,     2,   124,   125,     2,
     108,   109,   122,   118,   111,   119,   117,   123,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   110,   105,
     112,   114,   113,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   115,     2,   116,   126,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   106,   127,   107,   121,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,  1510,  1510,  1512,  1546,  1554,  1557,  1562,  1584,  1608,
    1609,  1611,  1634,  1640,  1641,  1642,  1645,  1649,  1668,  1669,
    1671,  1681,  1688,  1696,  1730,  1735,  1742,  1746,  1747,  1750,
    1754,  1759,  1765,  1771,  1776,  1785,  1790,  1795,  1806,  1817,
    1834,  1837,  1848,  1852,  1856,  1863,  1867,  1884,  1910,  1914,
    1918,  1922,  1926,  1930,  1934,  1939,  1947,  1948,  1949,  1960,
    1961,  1963,  1979,  1985,  1991,  1999,  2010,  2013,  2018,  2024,
    2030,  2039,  2052,  2055,  2079,  2082,  2086,  2090,  2094,  2098,
    2102,  2106,  2110,  2114,  2118,  2122,  2127,  2135,  2139,  2144,
    2149,  2157,  2167,  2171,  2176,  2180,  2187,  2188,  2189,  2190,
    2191,  2192,  2196,  2202,  2211,  2231,  2236,  2242,  2246,  2250,
    2255,  2264,  2269,  2274,  2288,  2302,  2316,  2335,  2340,  2344,
    2361,  2378,  2427,  2451,  2521,  2525,  2537,  2549,  2564,  2592,
    2596,  2600,  2604,  2611,  2612,  2616,  2620,  2627,  2628,  2632,
    2637,  2641,  2645,  2652,  2653,  2657,  2661,  2665,  2672,  2673,
    2677,  2682,  2686,  2691,  2695,  2700,  2704,  2709,  2713,  2718,
    2722,  2727,  2731,  2738,  2739,  2755,  2759,  2763,  2767,  2771,
    2775,  2779,  2783,  2787,  2791,  2795,  2800,  2804
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "KW_BLENDSTATE",
  "KW_BREAK", "KW_BUFFER", "KW_CBUFFER", "KW_COLUMN_MAJOR", "KW_COMPILE",
  "KW_CONST", "KW_CONTINUE", "KW_DEPTHSTENCILSTATE", "KW_DEPTHSTENCILVIEW",
  "KW_DISCARD", "KW_DO", "KW_DOUBLE", "KW_ELSE", "KW_EXTERN", "KW_FALSE",
  "KW_FOR", "KW_GEOMETRYSHADER", "KW_GROUPSHARED", "KW_IF", "KW_IN",
  "KW_INLINE", "KW_INOUT", "KW_MATRIX", "KW_NAMESPACE",
  "KW_NOINTERPOLATION", "KW_OUT", "KW_PASS", "KW_PIXELSHADER",
  "KW_PRECISE", "KW_RASTERIZERSTATE", "KW_RENDERTARGETVIEW", "KW_RETURN",
  "KW_REGISTER", "KW_ROW_MAJOR", "KW_SAMPLER", "KW_SAMPLER1D",
  "KW_SAMPLER2D", "KW_SAMPLER3D", "KW_SAMPLERCUBE", "KW_SAMPLER_STATE",
  "KW_SAMPLERCOMPARISONSTATE", "KW_SHARED", "KW_STATEBLOCK",
  "KW_STATEBLOCK_STATE", "KW_STATIC", "KW_STRING", "KW_STRUCT",
  "KW_SWITCH", "KW_TBUFFER", "KW_TECHNIQUE", "KW_TECHNIQUE10",
  "KW_TEXTURE", "KW_TEXTURE1D", "KW_TEXTURE1DARRAY", "KW_TEXTURE2D",
  "KW_TEXTURE2DARRAY", "KW_TEXTURE2DMS", "KW_TEXTURE2DMSARRAY",
  "KW_TEXTURE3D", "KW_TEXTURE3DARRAY", "KW_TEXTURECUBE", "KW_TRUE",
  "KW_TYPEDEF", "KW_UNIFORM", "KW_VECTOR", "KW_VERTEXSHADER", "KW_VOID",
  "KW_VOLATILE", "KW_WHILE", "OP_INC", "OP_DEC", "OP_AND", "OP_OR",
  "OP_EQ", "OP_LEFTSHIFT", "OP_LEFTSHIFTASSIGN", "OP_RIGHTSHIFT",
  "OP_RIGHTSHIFTASSIGN", "OP_ELLIPSIS", "OP_LE", "OP_GE", "OP_NE",
  "OP_ADDASSIGN", "OP_SUBASSIGN", "OP_MULASSIGN", "OP_DIVASSIGN",
  "OP_MODASSIGN", "OP_ANDASSIGN", "OP_ORASSIGN", "OP_XORASSIGN",
  "OP_UNKNOWN1", "OP_UNKNOWN2", "OP_UNKNOWN3", "OP_UNKNOWN4", "PRE_LINE",
  "VAR_IDENTIFIER", "TYPE_IDENTIFIER", "NEW_IDENTIFIER", "STRING",
  "C_FLOAT", "C_INTEGER", "';'", "'{'", "'}'", "'('", "')'", "':'", "','",
  "'<'", "'>'", "'='", "'['", "']'", "'.'", "'+'", "'-'", "'!'", "'~'",
  "'*'", "'/'", "'%'", "'&'", "'^'", "'|'", "'?'", "$accept", "hlsl_prog",
  "preproc_directive", "struct_declaration", "struct_spec",
  "named_struct_spec", "unnamed_struct_spec", "any_identifier",
  "fields_list", "field_type", "field", "func_declaration",
  "func_prototype", "compound_statement", "scope_start", "var_identifier",
  "colon_attribute", "semantic", "register_opt", "parameters",
  "param_list", "parameter", "input_mods", "input_mod", "type",
  "base_type", "declaration_statement", "typedef_type", "typedef",
  "type_specs", "type_spec", "declaration", "variables_def_optional",
  "variables_def", "variable_def", "array", "var_modifiers",
  "complex_initializer", "initializer_expr", "initializer_expr_list",
  "boolean", "statement_list", "statement", "jump_statement",
  "selection_statement", "if_body", "loop_statement", "expr_statement",
  "primary_expr", "postfix_expr", "unary_expr", "unary_op", "mul_expr",
  "add_expr", "shift_expr", "relational_expr", "equality_expr",
  "bitand_expr", "bitxor_expr", "bitor_expr", "logicand_expr",
  "logicor_expr", "conditional_expr", "assignment_expr", "assign_op",
  "expr", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   356,   357,   358,   359,    59,   123,   125,    40,    41,
      58,    44,    60,    62,    61,    91,    93,    46,    43,    45,
      33,   126,    42,    47,    37,    38,    94,   124,    63
};
#endif

#define YYPACT_NINF (-240)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-36)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -240,   707,  -240,   799,   799,   799,   799,   799,   799,   799,
     799,   799,   799,   799,   799,   -74,  -240,  -240,  -240,  -240,
     -41,  -240,  -240,  -240,   135,  -240,  -240,  -240,  -240,  -240,
    -240,  -240,  -240,  -240,   135,  -240,  -240,  -240,  -240,   -88,
    -240,   -57,  -240,  -240,  -240,  -240,  -240,    93,   -22,  -240,
    -240,   -69,  -240,  -240,    97,  -240,  -240,  -240,   -69,  -240,
     316,    -2,  -240,   -28,  -240,  -240,   -23,    -2,  -240,   -20,
      17,    27,  -240,    -5,    22,    57,   -61,   -20,   -60,  -240,
     316,  -240,    64,    96,   395,  -240,   100,   646,   646,  -240,
    -240,  -240,  -240,   646,  -240,  -240,  -240,  -240,  -240,  -240,
     135,  -240,   208,  -240,  -240,  -240,  -240,  -240,  -240,   -21,
      23,   646,    78,    71,    61,    16,   -43,     9,    94,    59,
     148,   -55,  -240,  -240,   -29,   128,   127,    26,  -240,   143,
     646,   145,  -240,   -69,  -240,  -240,  -240,  -240,   -69,   185,
    -240,   646,  -240,   250,   -25,   646,  -240,  -240,   250,    -3,
      19,  -240,  -240,  -240,  -240,   646,   -69,  -240,  -240,  -240,
    -240,  -240,  -240,  -240,  -240,  -240,  -240,  -240,   646,  -240,
     646,   646,   646,   646,   646,   646,   646,   646,   646,   646,
     646,   646,   646,   646,   646,   646,   646,   646,   646,  -240,
     646,  -240,   160,  -240,  -240,   328,   751,   161,   -70,   -12,
     152,  -240,  -240,  -240,   158,   159,  -240,   162,   456,    60,
     169,  -240,    73,   -59,  -240,   646,   -49,  -240,  -240,  -240,
    -240,  -240,  -240,    78,    78,    71,    71,    61,    61,    61,
      61,    16,    16,   -43,     9,    94,    59,   148,    68,  -240,
     167,    25,  -240,   -69,  -240,  -240,   156,  -240,   175,  -240,
     517,   173,  -240,   800,   145,   646,   456,   250,   456,   316,
     316,   176,  -240,   105,  -240,  -240,   646,   182,    31,  -240,
     -69,   646,  -240,  -240,  -240,  -240,  -240,  -240,  -240,   250,
    -240,   130,   646,   646,   271,  -240,  -240,   646,  -240,   646,
    -240,   180,  -240,   133,    10,  -240,   -69,   189,   137,   138,
     316,  -240,  -240,  -240,  -240,   -69,  -240,   585,   145,  -240,
     316,   316,  -240,   186,  -240,  -240,  -240,  -240,  -240
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       2,    74,     1,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,     0,     6,     5,    57,     3,
       0,     4,    58,    56,     0,    85,    83,    75,    79,    76,
      77,    84,    78,    80,     0,    81,    82,     7,    22,    26,
      21,     0,    49,    50,    51,    52,    53,     0,     0,    48,
      54,    66,     9,    10,     0,    45,    60,    59,     0,    24,
      74,     0,    13,    55,    15,    16,     0,     0,    14,    72,
       0,    67,    68,    13,    15,     0,     0,    72,     0,    62,
      74,    93,     0,     0,    74,    92,     0,    74,    74,   116,
     113,   114,   111,    74,   129,   130,   131,   132,    98,    96,
       0,   115,    74,    94,    99,   100,   101,    97,   118,   124,
     133,    74,   137,   140,   143,   148,   151,   153,   155,   157,
     159,   161,   163,   176,     0,     0,     0,    74,    16,     0,
      74,    29,     8,     0,    26,    65,    64,    61,     0,     0,
      26,    74,   103,     0,     0,    74,   125,   126,     0,     0,
       0,    25,    95,   119,   120,    74,     0,   171,   172,   166,
     167,   168,   169,   170,   173,   174,   175,   165,    74,   127,
      74,    74,    74,    74,    74,    74,    74,    74,    74,    74,
      74,    74,    74,    74,    74,    74,    74,    74,    74,   112,
      74,    55,     0,    12,    17,     0,    74,     0,     0,     0,
      70,    30,    31,    69,    40,     0,    63,     0,    74,     0,
       0,   102,     0,    72,   117,    74,     0,   121,   164,   134,
     135,   136,   133,   138,   139,   141,   142,   146,   147,   144,
     145,   149,   150,   152,   154,   156,   158,   160,     0,   177,
       0,     0,    19,     0,    18,    11,     0,    73,     0,    32,
      74,    36,    37,    74,    29,    74,    74,     0,    74,    74,
      74,     0,    90,     0,    89,   122,    74,     0,     0,    46,
       0,    74,    71,    86,    40,    42,    44,    43,    41,     0,
      23,     0,    74,    74,   105,   104,   107,    74,   123,    74,
     162,     0,    20,     0,     0,    38,     0,     0,     0,     0,
      74,   128,    91,    47,    33,     0,    87,    74,    29,   108,
      74,    74,   106,     0,    88,    39,   110,   109,    34
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -240,  -240,  -240,  -240,   262,  -240,   102,   -33,   170,  -240,
    -240,  -240,  -240,   281,    28,  -240,  -239,  -240,  -240,  -240,
    -240,    29,  -240,  -240,    -8,   103,   301,  -240,  -240,  -240,
     166,    98,  -240,   -34,   172,   -50,    -1,  -240,  -232,    37,
    -240,  -240,   -79,  -240,  -240,  -240,  -240,  -186,  -240,  -240,
     -27,  -240,    77,    58,    33,    80,   134,   140,   136,   146,
     132,  -240,  -240,   -83,  -240,   -64
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    17,    18,    51,    52,    53,    69,   127,   243,
     194,    19,    20,    98,    60,    75,   200,   201,   202,   205,
     251,   252,   253,   278,   150,    55,    99,    58,    22,    78,
      79,    23,    70,    76,    72,   131,   143,   272,   262,   263,
     101,   102,   103,   104,   105,   285,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   168,   124
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      24,   139,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    66,   280,    54,    71,   273,    59,
     144,   187,   258,   152,   248,    77,    57,   136,    37,   149,
      62,    68,    64,     3,   181,     4,    42,    43,    44,    45,
      46,   190,   182,     5,   135,   137,   247,     6,   125,   215,
     133,   138,   153,   154,     7,    61,   130,   302,     8,   100,
     146,   147,   190,     9,    38,    39,   198,   265,    49,   315,
     282,    10,   283,   188,    11,   302,   189,   209,   -14,   100,
     211,   212,   190,   128,   169,   218,   190,    62,    68,    64,
      67,   216,   148,    13,   155,   130,   156,    14,    50,   177,
     178,   100,   157,   -27,   158,    77,   214,   239,   190,   159,
     160,   161,   162,   163,   164,   165,   166,   306,    62,    68,
      64,   307,   132,   217,   238,   191,   195,   215,   179,   180,
     -28,    65,   264,   193,   183,   210,   292,   167,   133,   175,
     213,   176,   133,   219,   220,   221,   222,   222,   222,   222,
     222,   222,   222,   222,   222,   222,   222,   222,   222,   222,
     222,    41,   204,   261,   126,   134,   249,   264,   208,   259,
     129,   190,   140,    42,    43,    44,    45,    46,   266,   190,
     284,   286,   260,   290,   190,    47,   185,   244,   264,   173,
     174,   281,    62,    63,    64,   195,    73,    68,    74,    65,
     170,   171,   172,    48,   141,    49,   264,   257,   145,   268,
     227,   228,   229,   230,   288,     3,   289,     4,   298,   299,
     184,   312,    80,   186,   264,     5,    81,    82,   191,     6,
      83,   316,   317,   225,   226,    50,     7,   293,   192,   297,
       8,   190,   304,    84,   305,     9,   310,   311,   190,   190,
     223,   224,   279,    10,   197,   199,    11,   207,   100,   100,
     301,   231,   232,   308,   240,   246,   250,   -35,   254,   269,
     255,   296,   313,    85,    12,    13,    41,   215,   267,    14,
      86,    87,    88,   270,   274,   287,   291,   300,    42,    43,
      44,    45,    46,   303,   309,   318,    56,   242,   196,   100,
     125,    40,    21,   295,   206,   203,   256,    89,   294,   100,
     100,    90,    91,    92,    39,   151,    93,   233,    48,   237,
      49,   235,     0,     3,   234,     4,    94,    95,    96,    97,
      80,     0,   236,     5,    81,    82,     0,     6,    83,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     8,     0,
      50,    84,     0,     9,    41,     0,     0,     0,     0,     0,
       0,    10,     0,     0,    11,     0,    42,    43,    44,    45,
      46,     0,     0,     0,     0,     0,     0,     0,   241,     0,
       0,    85,    12,    13,     0,     0,     0,    14,    86,    87,
      88,     0,     0,     0,     0,     0,    48,     0,    49,     0,
       0,     0,     3,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     5,    81,     0,    89,     6,     0,     0,    90,
      91,    92,    39,     7,    93,     0,     0,     8,    50,     0,
       0,     0,     9,     0,    94,    95,    96,    97,     0,     0,
      10,     0,     0,    11,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      85,     0,    13,     3,     0,     4,    14,     0,    87,    88,
       0,     0,     0,     5,    81,     0,     0,     6,     0,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     8,     0,
       0,     0,     0,     9,    89,     0,     0,     0,    90,    91,
     142,    10,     0,    93,    11,     0,     0,     0,     0,     0,
       0,     0,     0,    94,    95,    96,    97,     0,     0,     0,
       0,    85,     0,    13,     3,     0,     4,    14,     0,    87,
      88,     0,     0,     0,     5,    81,     0,     0,     6,     0,
       0,     0,     0,     0,     0,     7,     0,     0,     0,     8,
       0,     0,     0,     0,     9,    89,     0,     0,     0,    90,
      91,    92,    10,     0,    93,    11,     0,     0,     0,     0,
       0,     0,     0,     0,    94,    95,    96,    97,     0,     0,
       0,     0,    85,     0,    13,     0,     0,     0,    14,     0,
      87,    88,     3,     0,     4,     0,     0,     0,     0,     0,
       0,     0,     5,    81,     0,     0,     6,     0,     0,     0,
       0,     0,     0,     7,     0,     0,    89,     8,     0,     0,
      90,    91,     9,   271,     0,    93,     0,     0,     0,     0,
      10,     0,     0,    11,     0,    94,    95,    96,    97,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      85,     0,    13,     3,     0,     4,    14,     0,    87,    88,
       0,     0,     0,     5,    81,     0,     0,     6,     0,     0,
       0,     0,     0,     0,     7,     0,     0,     0,     8,     0,
       0,     0,     0,     9,    89,     0,     0,     0,    90,    91,
       0,    10,   314,    93,    11,     0,     0,     0,     0,     0,
       0,     0,     0,    94,    95,    96,    97,     2,     0,     0,
       0,    85,     0,    13,     3,     0,     4,    14,     0,    87,
      88,     0,     0,     0,     5,     0,     0,     0,     6,     0,
       0,     0,     0,     0,     0,     7,     0,     0,     0,     8,
       0,     0,     0,     0,     9,    89,     0,     0,     0,    90,
      91,     0,    10,     0,    93,    11,     0,     0,     3,     0,
       4,     0,     0,     0,    94,    95,    96,    97,     5,     0,
       0,     0,     6,    12,    13,     0,     0,     0,    14,     7,
       0,     0,     0,     8,     0,     0,     0,     0,     9,     0,
       0,     0,     0,     0,     0,     0,    10,     0,     0,    11,
       0,     0,     0,     0,     0,    15,     3,     3,     4,     4,
       0,     0,    16,     0,     0,     0,     5,     5,    13,     0,
       6,     6,    14,   275,     0,   276,     0,     7,     7,   277,
       0,     8,     8,     0,     0,     0,     9,     9,     0,     0,
       0,     0,     0,     0,    10,    10,     0,    11,    11,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   245,     0,
       0,     0,     0,     0,     0,     0,    13,    13,     0,     0,
      14,    14
};

static const yytype_int16 yycheck[] =
{
       1,    80,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    47,   254,    24,    51,   250,   107,
      84,    76,   208,   102,    36,    58,    34,    77,   102,    93,
      99,   100,   101,     7,    77,     9,    38,    39,    40,    41,
      42,   111,    85,    17,   105,   105,   116,    21,    50,   108,
     111,   111,    73,    74,    28,   112,   115,   289,    32,    60,
      87,    88,   111,    37,   105,   106,   130,   116,    70,   308,
     256,    45,   258,   128,    48,   307,   105,   141,   106,    80,
     105,   145,   111,   106,   111,   168,   111,    99,   100,   101,
     112,   155,    93,    67,   115,   115,   117,    71,   100,    83,
      84,   102,    79,   108,    81,   138,   109,   190,   111,    86,
      87,    88,    89,    90,    91,    92,    93,   107,    99,   100,
     101,   111,   105,   156,   188,   100,   127,   108,   112,   113,
     108,   106,   215,   107,   125,   143,   105,   114,   111,    78,
     148,    80,   111,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,    26,   134,   213,    61,   108,   199,   250,   140,   109,
      67,   111,   108,    38,    39,    40,    41,    42,   110,   111,
     259,   260,   109,   266,   111,    50,   127,   195,   271,   118,
     119,   255,    99,   100,   101,   196,    99,   100,   101,   106,
     122,   123,   124,    68,   108,    70,   289,   208,   108,   243,
     177,   178,   179,   180,   109,     7,   111,     9,   282,   283,
     126,   300,    14,    75,   307,    17,    18,    19,   100,    21,
      22,   310,   311,   175,   176,   100,    28,   270,   111,   109,
      32,   111,   109,    35,   111,    37,   109,   109,   111,   111,
     173,   174,   253,    45,   111,   110,    48,    72,   259,   260,
     287,   181,   182,   296,   104,   104,   114,   109,   109,   113,
     108,   279,   305,    65,    66,    67,    26,   108,   111,    71,
      72,    73,    74,   108,   111,   109,   104,    16,    38,    39,
      40,    41,    42,   113,   105,   109,    34,   195,   128,   300,
      50,    20,     1,   274,   138,   133,   208,    99,   271,   310,
     311,   103,   104,   105,   106,   107,   108,   183,    68,   187,
      70,   185,    -1,     7,   184,     9,   118,   119,   120,   121,
      14,    -1,   186,    17,    18,    19,    -1,    21,    22,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    -1,
     100,    35,    -1,    37,    26,    -1,    -1,    -1,    -1,    -1,
      -1,    45,    -1,    -1,    48,    -1,    38,    39,    40,    41,
      42,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    50,    -1,
      -1,    65,    66,    67,    -1,    -1,    -1,    71,    72,    73,
      74,    -1,    -1,    -1,    -1,    -1,    68,    -1,    70,    -1,
      -1,    -1,     7,    -1,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    -1,    99,    21,    -1,    -1,   103,
     104,   105,   106,    28,   108,    -1,    -1,    32,   100,    -1,
      -1,    -1,    37,    -1,   118,   119,   120,   121,    -1,    -1,
      45,    -1,    -1,    48,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,     7,    -1,     9,    71,    -1,    73,    74,
      -1,    -1,    -1,    17,    18,    -1,    -1,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    37,    99,    -1,    -1,    -1,   103,   104,
     105,    45,    -1,   108,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   118,   119,   120,   121,    -1,    -1,    -1,
      -1,    65,    -1,    67,     7,    -1,     9,    71,    -1,    73,
      74,    -1,    -1,    -1,    17,    18,    -1,    -1,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    37,    99,    -1,    -1,    -1,   103,
     104,   105,    45,    -1,   108,    48,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   118,   119,   120,   121,    -1,    -1,
      -1,    -1,    65,    -1,    67,    -1,    -1,    -1,    71,    -1,
      73,    74,     7,    -1,     9,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    17,    18,    -1,    -1,    21,    -1,    -1,    -1,
      -1,    -1,    -1,    28,    -1,    -1,    99,    32,    -1,    -1,
     103,   104,    37,   106,    -1,   108,    -1,    -1,    -1,    -1,
      45,    -1,    -1,    48,    -1,   118,   119,   120,   121,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      65,    -1,    67,     7,    -1,     9,    71,    -1,    73,    74,
      -1,    -1,    -1,    17,    18,    -1,    -1,    21,    -1,    -1,
      -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,    -1,
      -1,    -1,    -1,    37,    99,    -1,    -1,    -1,   103,   104,
      -1,    45,   107,   108,    48,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   118,   119,   120,   121,     0,    -1,    -1,
      -1,    65,    -1,    67,     7,    -1,     9,    71,    -1,    73,
      74,    -1,    -1,    -1,    17,    -1,    -1,    -1,    21,    -1,
      -1,    -1,    -1,    -1,    -1,    28,    -1,    -1,    -1,    32,
      -1,    -1,    -1,    -1,    37,    99,    -1,    -1,    -1,   103,
     104,    -1,    45,    -1,   108,    48,    -1,    -1,     7,    -1,
       9,    -1,    -1,    -1,   118,   119,   120,   121,    17,    -1,
      -1,    -1,    21,    66,    67,    -1,    -1,    -1,    71,    28,
      -1,    -1,    -1,    32,    -1,    -1,    -1,    -1,    37,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    45,    -1,    -1,    48,
      -1,    -1,    -1,    -1,    -1,    98,     7,     7,     9,     9,
      -1,    -1,   105,    -1,    -1,    -1,    17,    17,    67,    -1,
      21,    21,    71,    23,    -1,    25,    -1,    28,    28,    29,
      -1,    32,    32,    -1,    -1,    -1,    37,    37,    -1,    -1,
      -1,    -1,    -1,    -1,    45,    45,    -1,    48,    48,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   107,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    67,    67,    -1,    -1,
      71,    71
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   130,     0,     7,     9,    17,    21,    28,    32,    37,
      45,    48,    66,    67,    71,    98,   105,   131,   132,   140,
     141,   155,   157,   160,   165,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   165,   102,   105,   106,
     142,    26,    38,    39,    40,    41,    42,    50,    68,    70,
     100,   133,   134,   135,   153,   154,   133,   153,   156,   107,
     143,   112,    99,   100,   101,   106,   136,   112,   100,   136,
     161,   162,   163,    99,   101,   144,   162,   136,   158,   159,
      14,    18,    19,    22,    35,    65,    72,    73,    74,    99,
     103,   104,   105,   108,   118,   119,   120,   121,   142,   155,
     165,   169,   170,   171,   172,   173,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   194,    50,   154,   137,   106,   154,
     115,   164,   105,   111,   108,   105,   164,   105,   111,   171,
     108,   108,   105,   165,   194,   108,   179,   179,   165,   194,
     153,   107,   171,    73,    74,   115,   117,    79,    81,    86,
      87,    88,    89,    90,    91,    92,    93,   114,   193,   179,
     122,   123,   124,   118,   119,    78,    80,    83,    84,   112,
     113,    77,    85,   125,   126,   127,    75,    76,   128,   105,
     111,   100,   111,   107,   139,   165,   137,   111,   194,   110,
     145,   146,   147,   163,   143,   148,   159,    72,   143,   194,
     153,   105,   194,   153,   109,   108,   194,   136,   192,   179,
     179,   179,   179,   181,   181,   182,   182,   183,   183,   183,
     183,   184,   184,   185,   186,   187,   188,   189,   194,   192,
     104,    50,   135,   138,   153,   107,   104,   116,    36,   136,
     114,   149,   150,   151,   109,   108,   160,   165,   176,   109,
     109,   164,   167,   168,   192,   116,   110,   111,   162,   113,
     108,   106,   166,   167,   111,    23,    25,    29,   152,   165,
     145,   194,   176,   176,   171,   174,   171,   109,   109,   111,
     192,   104,   105,   136,   168,   150,   153,   109,   194,   194,
      16,   179,   167,   113,   109,   111,   107,   111,   136,   105,
     109,   109,   171,   136,   107,   145,   171,   171,   109
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   129,   130,   130,   130,   130,   130,   131,   132,   133,
     133,   134,   135,   136,   136,   136,   137,   137,   138,   138,
     139,   140,   140,   141,   142,   142,   143,   144,   144,   145,
     145,   145,   146,   147,   147,   148,   148,   149,   149,   150,
     151,   151,   152,   152,   152,   153,   153,   153,   154,   154,
     154,   154,   154,   154,   154,   154,   155,   155,   155,   156,
     156,   157,   158,   158,   159,   160,   161,   161,   162,   162,
     163,   163,   164,   164,   165,   165,   165,   165,   165,   165,
     165,   165,   165,   165,   165,   165,   166,   166,   166,   167,
     168,   168,   169,   169,   170,   170,   171,   171,   171,   171,
     171,   171,   172,   172,   173,   174,   174,   175,   175,   175,
     175,   176,   176,   177,   177,   177,   177,   177,   178,   178,
     178,   178,   178,   178,   179,   179,   179,   179,   179,   180,
     180,   180,   180,   181,   181,   181,   181,   182,   182,   182,
     183,   183,   183,   184,   184,   184,   184,   184,   185,   185,
     185,   186,   186,   187,   187,   188,   188,   189,   189,   190,
     190,   191,   191,   192,   192,   193,   193,   193,   193,   193,
     193,   193,   193,   193,   193,   193,   194,   194
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     2,     2,     4,     1,
       1,     5,     4,     1,     1,     1,     0,     2,     1,     1,
       4,     2,     2,     7,     2,     4,     0,     1,     1,     0,
       1,     1,     2,     5,     7,     1,     2,     1,     3,     5,
       0,     2,     1,     1,     1,     1,     6,     8,     1,     1,
       1,     1,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     5,     1,     3,     2,     4,     0,     1,     1,     3,
       3,     5,     0,     3,     0,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     1,
       1,     3,     1,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     3,     2,     5,     1,     3,     5,     7,     8,
       8,     1,     2,     1,     1,     1,     1,     3,     1,     2,
       2,     3,     4,     5,     1,     2,     2,     2,     6,     1,
       1,     1,     1,     1,     3,     3,     3,     1,     3,     3,
       1,     3,     3,     1,     3,     3,     3,     3,     1,     3,
       3,     1,     3,     1,     3,     1,     3,     1,     3,     1,
       3,     1,     5,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF

/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

# ifndef YY_LOCATION_PRINT
#  if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#   define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

#  else
#   define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#  endif
# endif /* !defined YY_LOCATION_PRINT */


# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, Location); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yykind < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yykind], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yykind, yyvaluep, yylocationp);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)],
                       &(yylsp[(yyi + 1) - (yynrhs)]));
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
  YYLTYPE *yylloc;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Location data for the lookahead symbol.  */
YYLTYPE yylloc
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

    /* The location stack: array, bottom, top.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls = yylsa;
    YYLTYPE *yylsp = yyls;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* The locations where the error started and ended.  */
  YYLTYPE yyerror_range[3];

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      yyerror_range[1] = yylloc;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* hlsl_prog: %empty  */
#line 1510 "dlls/d3dcompiler_43/hlsl.y"
                            {
                            }
#line 3478 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 3: /* hlsl_prog: hlsl_prog func_declaration  */
#line 1513 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                const struct hlsl_ir_function_decl *decl;

                                decl = get_overloaded_func(&hlsl_ctx.functions, (yyvsp[0].function).name, (yyvsp[0].function).decl->parameters, TRUE);
                                if (decl && !decl->func->intrinsic)
                                {
                                    if (decl->body && (yyvsp[0].function).decl->body)
                                    {
                                        hlsl_report_message((yyvsp[0].function).decl->loc, HLSL_LEVEL_ERROR,
                                                "redefinition of function %s", debugstr_a((yyvsp[0].function).name));
                                        YYABORT;
                                    }
                                    else if (!compare_hlsl_types(decl->return_type, (yyvsp[0].function).decl->return_type))
                                    {
                                        hlsl_report_message((yyvsp[0].function).decl->loc, HLSL_LEVEL_ERROR,
                                                "redefining function %s with a different return type",
                                                debugstr_a((yyvsp[0].function).name));
                                        hlsl_report_message(decl->loc, HLSL_LEVEL_NOTE,
                                                "%s previously declared here",
                                                debugstr_a((yyvsp[0].function).name));
                                        YYABORT;
                                    }
                                }

                                if (type_is_void((yyvsp[0].function).decl->return_type) && (yyvsp[0].function).decl->semantic)
                                {
                                    hlsl_report_message((yyvsp[0].function).decl->loc, HLSL_LEVEL_ERROR,
                                            "void function with a semantic");
                                }

                                TRACE("Adding function '%s' to the function list.\n", (yyvsp[0].function).name);
                                add_function_decl(&hlsl_ctx.functions, (yyvsp[0].function).name, (yyvsp[0].function).decl, FALSE);
                            }
#line 3516 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 4: /* hlsl_prog: hlsl_prog declaration_statement  */
#line 1547 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                TRACE("Declaration statement parsed.\n");

                                if (!list_empty((yyvsp[0].list)))
                                    FIXME("Uniform initializer.\n");
                                free_instr_list((yyvsp[0].list));
                            }
#line 3528 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 5: /* hlsl_prog: hlsl_prog preproc_directive  */
#line 1555 "dlls/d3dcompiler_43/hlsl.y"
                            {
                            }
#line 3535 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 6: /* hlsl_prog: hlsl_prog ';'  */
#line 1558 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                TRACE("Skipping stray semicolon.\n");
                            }
#line 3543 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 7: /* preproc_directive: PRE_LINE STRING  */
#line 1563 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                const char **new_array = NULL;

                                TRACE("Updating line information to file %s, line %u\n", debugstr_a((yyvsp[0].name)), (yyvsp[-1].intval));
                                hlsl_ctx.line_no = (yyvsp[-1].intval);
                                if (strcmp((yyvsp[0].name), hlsl_ctx.source_file))
                                    new_array = d3dcompiler_realloc(hlsl_ctx.source_files,
                                            sizeof(*hlsl_ctx.source_files) * (hlsl_ctx.source_files_count + 1));

                                if (new_array)
                                {
                                    hlsl_ctx.source_files = new_array;
                                    hlsl_ctx.source_files[hlsl_ctx.source_files_count++] = (yyvsp[0].name);
                                    hlsl_ctx.source_file = (yyvsp[0].name);
                                }
                                else
                                {
                                    d3dcompiler_free((yyvsp[0].name));
                                }
                            }
#line 3568 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 8: /* struct_declaration: var_modifiers struct_spec variables_def_optional ';'  */
#line 1585 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_type *type;
                                DWORD modifiers = (yyvsp[-3].modifiers);

                                if (!(yyvsp[-1].list))
                                {
                                    if (!(yyvsp[-2].type)->name)
                                    {
                                        hlsl_report_message(get_location(&(yylsp[-2])), HLSL_LEVEL_ERROR,
                                                "anonymous struct declaration with no variables");
                                    }
                                    if (modifiers)
                                    {
                                        hlsl_report_message(get_location(&(yylsp[-3])), HLSL_LEVEL_ERROR,
                                                "modifier not allowed on struct type declaration");
                                    }
                                }

                                if (!(type = apply_type_modifiers((yyvsp[-2].type), &modifiers, get_location(&(yylsp[-3])))))
                                    YYABORT;
                                (yyval.list) = declare_vars(type, modifiers, (yyvsp[-1].list));
                            }
#line 3595 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 11: /* named_struct_spec: KW_STRUCT any_identifier '{' fields_list '}'  */
#line 1612 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                BOOL ret;

                                TRACE("Structure %s declaration.\n", debugstr_a((yyvsp[-3].name)));
                                (yyval.type) = new_struct_type((yyvsp[-3].name), (yyvsp[-1].list));

                                if (get_variable(hlsl_ctx.cur_scope, (yyvsp[-3].name)))
                                {
                                    hlsl_report_message(get_location(&(yylsp[-3])),
                                            HLSL_LEVEL_ERROR, "redefinition of '%s'", (yyvsp[-3].name));
                                    YYABORT;
                                }

                                ret = add_type_to_scope(hlsl_ctx.cur_scope, (yyval.type));
                                if (!ret)
                                {
                                    hlsl_report_message(get_location(&(yylsp[-3])),
                                            HLSL_LEVEL_ERROR, "redefinition of struct '%s'", (yyvsp[-3].name));
                                    YYABORT;
                                }
                            }
#line 3621 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 12: /* unnamed_struct_spec: KW_STRUCT '{' fields_list '}'  */
#line 1635 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                TRACE("Anonymous structure declaration.\n");
                                (yyval.type) = new_struct_type(NULL, (yyvsp[-1].list));
                            }
#line 3630 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 16: /* fields_list: %empty  */
#line 1645 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
#line 3639 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 17: /* fields_list: fields_list field  */
#line 1650 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                BOOL ret;
                                struct hlsl_struct_field *field, *next;

                                (yyval.list) = (yyvsp[-1].list);
                                LIST_FOR_EACH_ENTRY_SAFE(field, next, (yyvsp[0].list), struct hlsl_struct_field, entry)
                                {
                                    ret = add_struct_field((yyval.list), field);
                                    if (ret == FALSE)
                                    {
                                        hlsl_report_message(get_location(&(yylsp[0])),
                                                HLSL_LEVEL_ERROR, "redefinition of '%s'", field->name);
                                        d3dcompiler_free(field);
                                    }
                                }
                                d3dcompiler_free((yyvsp[0].list));
                            }
#line 3661 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 20: /* field: var_modifiers field_type variables_def ';'  */
#line 1672 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_type *type;
                                DWORD modifiers = (yyvsp[-3].modifiers);

                                if (!(type = apply_type_modifiers((yyvsp[-2].type), &modifiers, get_location(&(yylsp[-3])))))
                                    YYABORT;
                                (yyval.list) = gen_struct_fields(type, modifiers, (yyvsp[-1].list));
                            }
#line 3674 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 21: /* func_declaration: func_prototype compound_statement  */
#line 1682 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                TRACE("Function %s parsed.\n", (yyvsp[-1].function).name);
                                (yyval.function) = (yyvsp[-1].function);
                                (yyval.function).decl->body = (yyvsp[0].list);
                                pop_scope(&hlsl_ctx);
                            }
#line 3685 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 22: /* func_declaration: func_prototype ';'  */
#line 1689 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                TRACE("Function prototype for %s.\n", (yyvsp[-1].function).name);
                                (yyval.function) = (yyvsp[-1].function);
                                pop_scope(&hlsl_ctx);
                            }
#line 3695 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 23: /* func_prototype: var_modifiers type var_identifier '(' parameters ')' colon_attribute  */
#line 1697 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                if ((yyvsp[-6].modifiers))
                                {
                                    hlsl_report_message(get_location(&(yylsp[-6])), HLSL_LEVEL_ERROR,
                                            "unexpected modifiers on a function");
                                    YYABORT;
                                }
                                if (get_variable(hlsl_ctx.globals, (yyvsp[-4].name)))
                                {
                                    hlsl_report_message(get_location(&(yylsp[-4])),
                                            HLSL_LEVEL_ERROR, "redefinition of '%s'\n", (yyvsp[-4].name));
                                    YYABORT;
                                }
                                if (type_is_void((yyvsp[-5].type)) && (yyvsp[0].colon_attribute).semantic)
                                {
                                    hlsl_report_message(get_location(&(yylsp[0])),
                                            HLSL_LEVEL_ERROR, "void function with a semantic");
                                }

                                if ((yyvsp[0].colon_attribute).reg_reservation)
                                {
                                    FIXME("Unexpected register reservation for a function.\n");
                                    d3dcompiler_free((yyvsp[0].colon_attribute).reg_reservation);
                                }
                                if (!((yyval.function).decl = new_func_decl((yyvsp[-5].type), (yyvsp[-2].list), (yyvsp[0].colon_attribute).semantic, get_location(&(yylsp[-4])))))
                                {
                                    ERR("Out of memory.\n");
                                    YYABORT;
                                }
                                (yyval.function).name = (yyvsp[-4].name);
                                hlsl_ctx.cur_function = (yyval.function).decl;
                            }
#line 3732 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 24: /* compound_statement: '{' '}'  */
#line 1731 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
#line 3741 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 25: /* compound_statement: '{' scope_start statement_list '}'  */
#line 1736 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                pop_scope(&hlsl_ctx);
                                (yyval.list) = (yyvsp[-1].list);
                            }
#line 3750 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 26: /* scope_start: %empty  */
#line 1742 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                push_scope(&hlsl_ctx);
                            }
#line 3758 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 29: /* colon_attribute: %empty  */
#line 1750 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.colon_attribute).semantic = NULL;
                                (yyval.colon_attribute).reg_reservation = NULL;
                            }
#line 3767 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 30: /* colon_attribute: semantic  */
#line 1755 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.colon_attribute).semantic = (yyvsp[0].name);
                                (yyval.colon_attribute).reg_reservation = NULL;
                            }
#line 3776 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 31: /* colon_attribute: register_opt  */
#line 1760 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.colon_attribute).semantic = NULL;
                                (yyval.colon_attribute).reg_reservation = (yyvsp[0].reg_reservation);
                            }
#line 3785 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 32: /* semantic: ':' any_identifier  */
#line 1766 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.name) = (yyvsp[0].name);
                            }
#line 3793 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 33: /* register_opt: ':' KW_REGISTER '(' any_identifier ')'  */
#line 1772 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.reg_reservation) = parse_reg_reservation((yyvsp[-1].name));
                                d3dcompiler_free((yyvsp[-1].name));
                            }
#line 3802 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 34: /* register_opt: ':' KW_REGISTER '(' any_identifier ',' any_identifier ')'  */
#line 1777 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("Ignoring shader target %s in a register reservation.\n", debugstr_a((yyvsp[-3].name)));
                                d3dcompiler_free((yyvsp[-3].name));

                                (yyval.reg_reservation) = parse_reg_reservation((yyvsp[-1].name));
                                d3dcompiler_free((yyvsp[-1].name));
                            }
#line 3814 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 35: /* parameters: scope_start  */
#line 1786 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
#line 3823 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 36: /* parameters: scope_start param_list  */
#line 1791 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 3831 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 37: /* param_list: parameter  */
#line 1796 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                if (!add_func_parameter((yyval.list), &(yyvsp[0].parameter), get_location(&(yylsp[0]))))
                                {
                                    ERR("Error adding function parameter %s.\n", (yyvsp[0].parameter).name);
                                    set_parse_status(&hlsl_ctx.status, PARSE_ERR);
                                    YYABORT;
                                }
                            }
#line 3846 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 38: /* param_list: param_list ',' parameter  */
#line 1807 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-2].list);
                                if (!add_func_parameter((yyval.list), &(yyvsp[0].parameter), get_location(&(yylsp[0]))))
                                {
                                    hlsl_report_message(get_location(&(yylsp[0])), HLSL_LEVEL_ERROR,
                                            "duplicate parameter %s", (yyvsp[0].parameter).name);
                                    YYABORT;
                                }
                            }
#line 3860 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 39: /* parameter: input_mods var_modifiers type any_identifier colon_attribute  */
#line 1818 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_type *type;
                                DWORD modifiers = (yyvsp[-3].modifiers);

                                if (!(type = apply_type_modifiers((yyvsp[-2].type), &modifiers, get_location(&(yylsp[-3])))))
                                    YYABORT;

                                (yyval.parameter).modifiers = (yyvsp[-4].modifiers) ? (yyvsp[-4].modifiers) : HLSL_STORAGE_IN;
                                (yyval.parameter).modifiers |= modifiers;
                                (yyval.parameter).type = type;
                                (yyval.parameter).name = (yyvsp[-1].name);
                                (yyval.parameter).semantic = (yyvsp[0].colon_attribute).semantic;
                                (yyval.parameter).reg_reservation = (yyvsp[0].colon_attribute).reg_reservation;
                            }
#line 3879 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 40: /* input_mods: %empty  */
#line 1834 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = 0;
                            }
#line 3887 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 41: /* input_mods: input_mods input_mod  */
#line 1838 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                if ((yyvsp[-1].modifiers) & (yyvsp[0].modifiers))
                                {
                                    hlsl_report_message(get_location(&(yylsp[0])), HLSL_LEVEL_ERROR,
                                            "duplicate input-output modifiers");
                                    YYABORT;
                                }
                                (yyval.modifiers) = (yyvsp[-1].modifiers) | (yyvsp[0].modifiers);
                            }
#line 3901 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 42: /* input_mod: KW_IN  */
#line 1849 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = HLSL_STORAGE_IN;
                            }
#line 3909 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 43: /* input_mod: KW_OUT  */
#line 1853 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = HLSL_STORAGE_OUT;
                            }
#line 3917 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 44: /* input_mod: KW_INOUT  */
#line 1857 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = HLSL_STORAGE_IN | HLSL_STORAGE_OUT;
                            }
#line 3925 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 45: /* type: base_type  */
#line 1864 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = (yyvsp[0].type);
        }
#line 3933 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 46: /* type: KW_VECTOR '<' base_type ',' C_INTEGER '>'  */
#line 1868 "dlls/d3dcompiler_43/hlsl.y"
        {
            if ((yyvsp[-3].type)->type != HLSL_CLASS_SCALAR)
            {
                hlsl_report_message(get_location(&(yylsp[-3])), HLSL_LEVEL_ERROR,
                        "vectors of non-scalar types are not allowed\n");
                YYABORT;
            }
            if ((yyvsp[-1].intval) < 1 || (yyvsp[-1].intval) > 4)
            {
                hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR,
                        "vector size must be between 1 and 4\n");
                YYABORT;
            }

            (yyval.type) = new_hlsl_type(NULL, HLSL_CLASS_VECTOR, (yyvsp[-3].type)->base_type, (yyvsp[-1].intval), 1);
        }
#line 3954 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 47: /* type: KW_MATRIX '<' base_type ',' C_INTEGER ',' C_INTEGER '>'  */
#line 1885 "dlls/d3dcompiler_43/hlsl.y"
        {
            if ((yyvsp[-5].type)->type != HLSL_CLASS_SCALAR)
            {
                hlsl_report_message(get_location(&(yylsp[-5])), HLSL_LEVEL_ERROR,
                        "matrices of non-scalar types are not allowed\n");
                YYABORT;
            }
            if ((yyvsp[-3].intval) < 1 || (yyvsp[-3].intval) > 4)
            {
                hlsl_report_message(get_location(&(yylsp[-3])), HLSL_LEVEL_ERROR,
                        "matrix row count must be between 1 and 4\n");
                YYABORT;
            }
            if ((yyvsp[-1].intval) < 1 || (yyvsp[-1].intval) > 4)
            {
                hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR,
                        "matrix column count must be between 1 and 4\n");
                YYABORT;
            }

            (yyval.type) = new_hlsl_type(NULL, HLSL_CLASS_MATRIX, (yyvsp[-5].type)->base_type, (yyvsp[-1].intval), (yyvsp[-3].intval));
        }
#line 3981 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 48: /* base_type: KW_VOID  */
#line 1911 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = hlsl_ctx.builtin_types.Void;
        }
#line 3989 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 49: /* base_type: KW_SAMPLER  */
#line 1915 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = hlsl_ctx.builtin_types.sampler[HLSL_SAMPLER_DIM_GENERIC];
        }
#line 3997 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 50: /* base_type: KW_SAMPLER1D  */
#line 1919 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = hlsl_ctx.builtin_types.sampler[HLSL_SAMPLER_DIM_1D];
        }
#line 4005 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 51: /* base_type: KW_SAMPLER2D  */
#line 1923 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = hlsl_ctx.builtin_types.sampler[HLSL_SAMPLER_DIM_2D];
        }
#line 4013 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 52: /* base_type: KW_SAMPLER3D  */
#line 1927 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = hlsl_ctx.builtin_types.sampler[HLSL_SAMPLER_DIM_3D];
        }
#line 4021 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 53: /* base_type: KW_SAMPLERCUBE  */
#line 1931 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = hlsl_ctx.builtin_types.sampler[HLSL_SAMPLER_DIM_3D];
        }
#line 4029 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 54: /* base_type: TYPE_IDENTIFIER  */
#line 1935 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = get_type(hlsl_ctx.cur_scope, (yyvsp[0].name), TRUE);
            d3dcompiler_free((yyvsp[0].name));
        }
#line 4038 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 55: /* base_type: KW_STRUCT TYPE_IDENTIFIER  */
#line 1940 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.type) = get_type(hlsl_ctx.cur_scope, (yyvsp[0].name), TRUE);
            if ((yyval.type)->type != HLSL_CLASS_STRUCT)
                hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR, "'%s' redefined as a structure\n", (yyvsp[0].name));
            d3dcompiler_free((yyvsp[0].name));
        }
#line 4049 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 58: /* declaration_statement: typedef  */
#line 1950 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                if (!(yyval.list))
                                {
                                    ERR("Out of memory\n");
                                    YYABORT;
                                }
                                list_init((yyval.list));
                            }
#line 4063 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 61: /* typedef: KW_TYPEDEF var_modifiers typedef_type type_specs ';'  */
#line 1964 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                if ((yyvsp[-3].modifiers) & ~HLSL_TYPE_MODIFIERS_MASK)
                                {
                                    struct parse_variable_def *v, *v_next;
                                    hlsl_report_message(get_location(&(yylsp[-4])),
                                            HLSL_LEVEL_ERROR, "modifier not allowed on typedefs");
                                    LIST_FOR_EACH_ENTRY_SAFE(v, v_next, (yyvsp[-1].list), struct parse_variable_def, entry)
                                        d3dcompiler_free(v);
                                    d3dcompiler_free((yyvsp[-1].list));
                                    YYABORT;
                                }
                                if (!add_typedef((yyvsp[-3].modifiers), (yyvsp[-2].type), (yyvsp[-1].list)))
                                    YYABORT;
                            }
#line 4082 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 62: /* type_specs: type_spec  */
#line 1980 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[0].variable_def)->entry);
                            }
#line 4092 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 63: /* type_specs: type_specs ',' type_spec  */
#line 1986 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-2].list);
                                list_add_tail((yyval.list), &(yyvsp[0].variable_def)->entry);
                            }
#line 4101 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 64: /* type_spec: any_identifier array  */
#line 1992 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                (yyval.variable_def)->loc = get_location(&(yylsp[-1]));
                                (yyval.variable_def)->name = (yyvsp[-1].name);
                                (yyval.variable_def)->array_size = (yyvsp[0].intval);
                            }
#line 4112 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 65: /* declaration: var_modifiers type variables_def ';'  */
#line 2000 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_type *type;
                                DWORD modifiers = (yyvsp[-3].modifiers);

                                if (!(type = apply_type_modifiers((yyvsp[-2].type), &modifiers, get_location(&(yylsp[-3])))))
                                    YYABORT;
                                (yyval.list) = declare_vars(type, modifiers, (yyvsp[-1].list));
                            }
#line 4125 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 66: /* variables_def_optional: %empty  */
#line 2010 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = NULL;
                            }
#line 4133 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 67: /* variables_def_optional: variables_def  */
#line 2014 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4141 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 68: /* variables_def: variable_def  */
#line 2019 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                                list_add_head((yyval.list), &(yyvsp[0].variable_def)->entry);
                            }
#line 4151 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 69: /* variables_def: variables_def ',' variable_def  */
#line 2025 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-2].list);
                                list_add_tail((yyval.list), &(yyvsp[0].variable_def)->entry);
                            }
#line 4160 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 70: /* variable_def: any_identifier array colon_attribute  */
#line 2031 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                (yyval.variable_def)->loc = get_location(&(yylsp[-2]));
                                (yyval.variable_def)->name = (yyvsp[-2].name);
                                (yyval.variable_def)->array_size = (yyvsp[-1].intval);
                                (yyval.variable_def)->semantic = (yyvsp[0].colon_attribute).semantic;
                                (yyval.variable_def)->reg_reservation = (yyvsp[0].colon_attribute).reg_reservation;
                            }
#line 4173 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 71: /* variable_def: any_identifier array colon_attribute '=' complex_initializer  */
#line 2040 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                TRACE("Declaration with initializer.\n");
                                (yyval.variable_def) = d3dcompiler_alloc(sizeof(*(yyval.variable_def)));
                                (yyval.variable_def)->loc = get_location(&(yylsp[-4]));
                                (yyval.variable_def)->name = (yyvsp[-4].name);
                                (yyval.variable_def)->array_size = (yyvsp[-3].intval);
                                (yyval.variable_def)->semantic = (yyvsp[-2].colon_attribute).semantic;
                                (yyval.variable_def)->reg_reservation = (yyvsp[-2].colon_attribute).reg_reservation;
                                (yyval.variable_def)->initializer = (yyvsp[0].initializer);
                            }
#line 4188 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 72: /* array: %empty  */
#line 2052 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.intval) = 0;
                            }
#line 4196 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 73: /* array: '[' expr ']'  */
#line 2056 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                unsigned int size = evaluate_array_dimension(node_from_list((yyvsp[-1].list)));

                                free_instr_list((yyvsp[-1].list));

                                if (!size)
                                {
                                    hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR,
                                            "array size is not a positive integer constant\n");
                                    YYABORT;
                                }
                                TRACE("Array size %u.\n", size);

                                if (size > 65536)
                                {
                                    hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR,
                                            "array size must be between 1 and 65536");
                                    YYABORT;
                                }
                                (yyval.intval) = size;
                            }
#line 4222 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 74: /* var_modifiers: %empty  */
#line 2079 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = 0;
                            }
#line 4230 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 75: /* var_modifiers: KW_EXTERN var_modifiers  */
#line 2083 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_EXTERN, get_location(&(yylsp[-1])));
                            }
#line 4238 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 76: /* var_modifiers: KW_NOINTERPOLATION var_modifiers  */
#line 2087 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_NOINTERPOLATION, get_location(&(yylsp[-1])));
                            }
#line 4246 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 77: /* var_modifiers: KW_PRECISE var_modifiers  */
#line 2091 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_MODIFIER_PRECISE, get_location(&(yylsp[-1])));
                            }
#line 4254 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 78: /* var_modifiers: KW_SHARED var_modifiers  */
#line 2095 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_SHARED, get_location(&(yylsp[-1])));
                            }
#line 4262 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 79: /* var_modifiers: KW_GROUPSHARED var_modifiers  */
#line 2099 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_GROUPSHARED, get_location(&(yylsp[-1])));
                            }
#line 4270 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 80: /* var_modifiers: KW_STATIC var_modifiers  */
#line 2103 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_STATIC, get_location(&(yylsp[-1])));
                            }
#line 4278 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 81: /* var_modifiers: KW_UNIFORM var_modifiers  */
#line 2107 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_UNIFORM, get_location(&(yylsp[-1])));
                            }
#line 4286 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 82: /* var_modifiers: KW_VOLATILE var_modifiers  */
#line 2111 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_STORAGE_VOLATILE, get_location(&(yylsp[-1])));
                            }
#line 4294 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 83: /* var_modifiers: KW_CONST var_modifiers  */
#line 2115 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_MODIFIER_CONST, get_location(&(yylsp[-1])));
                            }
#line 4302 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 84: /* var_modifiers: KW_ROW_MAJOR var_modifiers  */
#line 2119 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_MODIFIER_ROW_MAJOR, get_location(&(yylsp[-1])));
                            }
#line 4310 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 85: /* var_modifiers: KW_COLUMN_MAJOR var_modifiers  */
#line 2123 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.modifiers) = add_modifiers((yyvsp[0].modifiers), HLSL_MODIFIER_COLUMN_MAJOR, get_location(&(yylsp[-1])));
                            }
#line 4318 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 86: /* complex_initializer: initializer_expr  */
#line 2128 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.initializer).args_count = 1;
                                if (!((yyval.initializer).args = d3dcompiler_alloc(sizeof(*(yyval.initializer).args))))
                                    YYABORT;
                                (yyval.initializer).args[0] = node_from_list((yyvsp[0].list));
                                (yyval.initializer).instrs = (yyvsp[0].list);
                            }
#line 4330 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 87: /* complex_initializer: '{' initializer_expr_list '}'  */
#line 2136 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.initializer) = (yyvsp[-1].initializer);
                            }
#line 4338 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 88: /* complex_initializer: '{' initializer_expr_list ',' '}'  */
#line 2140 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.initializer) = (yyvsp[-2].initializer);
                            }
#line 4346 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 89: /* initializer_expr: assignment_expr  */
#line 2145 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4354 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 90: /* initializer_expr_list: initializer_expr  */
#line 2150 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.initializer).args_count = 1;
                                if (!((yyval.initializer).args = d3dcompiler_alloc(sizeof(*(yyval.initializer).args))))
                                    YYABORT;
                                (yyval.initializer).args[0] = node_from_list((yyvsp[0].list));
                                (yyval.initializer).instrs = (yyvsp[0].list);
                            }
#line 4366 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 91: /* initializer_expr_list: initializer_expr_list ',' initializer_expr  */
#line 2158 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.initializer) = (yyvsp[-2].initializer);
                                if (!((yyval.initializer).args = d3dcompiler_realloc((yyval.initializer).args, ((yyval.initializer).args_count + 1) * sizeof(*(yyval.initializer).args))))
                                    YYABORT;
                                (yyval.initializer).args[(yyval.initializer).args_count++] = node_from_list((yyvsp[0].list));
                                list_move_tail((yyval.initializer).instrs, (yyvsp[0].list));
                                d3dcompiler_free((yyvsp[0].list));
                            }
#line 4379 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 92: /* boolean: KW_TRUE  */
#line 2168 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.boolval) = TRUE;
                            }
#line 4387 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 93: /* boolean: KW_FALSE  */
#line 2172 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.boolval) = FALSE;
                            }
#line 4395 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 94: /* statement_list: statement  */
#line 2177 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4403 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 95: /* statement_list: statement_list statement  */
#line 2181 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-1].list);
                                list_move_tail((yyval.list), (yyvsp[0].list));
                                d3dcompiler_free((yyvsp[0].list));
                            }
#line 4413 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 102: /* jump_statement: KW_RETURN expr ';'  */
#line 2197 "dlls/d3dcompiler_43/hlsl.y"
        {
            if (!add_return((yyvsp[-1].list), node_from_list((yyvsp[-1].list)), get_location(&(yylsp[-2]))))
                YYABORT;
            (yyval.list) = (yyvsp[-1].list);
        }
#line 4423 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 103: /* jump_statement: KW_RETURN ';'  */
#line 2203 "dlls/d3dcompiler_43/hlsl.y"
        {
            if (!((yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)))))
                YYABORT;
            list_init((yyval.list));
            if (!add_return((yyval.list), NULL, get_location(&(yylsp[-1]))))
                YYABORT;
        }
#line 4435 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 104: /* selection_statement: KW_IF '(' expr ')' if_body  */
#line 2212 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_ir_node *condition = node_from_list((yyvsp[-2].list));
                                struct hlsl_ir_if *instr;

                                if (!(instr = new_if(condition, get_location(&(yylsp[-4])))))
                                    YYABORT;
                                list_move_tail(&instr->then_instrs, (yyvsp[0].if_body).then_instrs);
                                list_move_tail(&instr->else_instrs, (yyvsp[0].if_body).else_instrs);
                                d3dcompiler_free((yyvsp[0].if_body).then_instrs);
                                d3dcompiler_free((yyvsp[0].if_body).else_instrs);
                                if (condition->data_type->dimx > 1 || condition->data_type->dimy > 1)
                                {
                                    hlsl_report_message(instr->node.loc, HLSL_LEVEL_ERROR,
                                            "if condition requires a scalar");
                                }
                                (yyval.list) = (yyvsp[-2].list);
                                list_add_tail((yyval.list), &instr->node.entry);
                            }
#line 4458 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 105: /* if_body: statement  */
#line 2232 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.if_body).then_instrs = (yyvsp[0].list);
                                (yyval.if_body).else_instrs = NULL;
                            }
#line 4467 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 106: /* if_body: statement KW_ELSE statement  */
#line 2237 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.if_body).then_instrs = (yyvsp[-2].list);
                                (yyval.if_body).else_instrs = (yyvsp[0].list);
                            }
#line 4476 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 107: /* loop_statement: KW_WHILE '(' expr ')' statement  */
#line 2243 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = create_loop(LOOP_WHILE, NULL, (yyvsp[-2].list), NULL, (yyvsp[0].list), get_location(&(yylsp[-4])));
                            }
#line 4484 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 108: /* loop_statement: KW_DO statement KW_WHILE '(' expr ')' ';'  */
#line 2247 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = create_loop(LOOP_DO_WHILE, NULL, (yyvsp[-2].list), NULL, (yyvsp[-5].list), get_location(&(yylsp[-6])));
                            }
#line 4492 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 109: /* loop_statement: KW_FOR '(' scope_start expr_statement expr_statement expr ')' statement  */
#line 2251 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = create_loop(LOOP_FOR, (yyvsp[-4].list), (yyvsp[-3].list), (yyvsp[-2].list), (yyvsp[0].list), get_location(&(yylsp[-7])));
                                pop_scope(&hlsl_ctx);
                            }
#line 4501 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 110: /* loop_statement: KW_FOR '(' scope_start declaration expr_statement expr ')' statement  */
#line 2256 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                if (!(yyvsp[-4].list))
                                    hlsl_report_message(get_location(&(yylsp[-4])), HLSL_LEVEL_WARNING,
                                            "no expressions in for loop initializer");
                                (yyval.list) = create_loop(LOOP_FOR, (yyvsp[-4].list), (yyvsp[-3].list), (yyvsp[-2].list), (yyvsp[0].list), get_location(&(yylsp[-7])));
                                pop_scope(&hlsl_ctx);
                            }
#line 4513 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 111: /* expr_statement: ';'  */
#line 2265 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = d3dcompiler_alloc(sizeof(*(yyval.list)));
                                list_init((yyval.list));
                            }
#line 4522 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 112: /* expr_statement: expr ';'  */
#line 2270 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-1].list);
                            }
#line 4530 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 113: /* primary_expr: C_FLOAT  */
#line 2275 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    YYABORT;
                                }
                                init_node(&c->node, HLSL_IR_CONSTANT,
                                        hlsl_ctx.builtin_types.scalar[HLSL_TYPE_FLOAT], get_location(&(yylsp[0])));
                                c->value.f[0] = (yyvsp[0].floatval);
                                if (!((yyval.list) = make_list(&c->node)))
                                    YYABORT;
                            }
#line 4548 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 114: /* primary_expr: C_INTEGER  */
#line 2289 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    YYABORT;
                                }
                                init_node(&c->node, HLSL_IR_CONSTANT,
                                        hlsl_ctx.builtin_types.scalar[HLSL_TYPE_INT], get_location(&(yylsp[0])));
                                c->value.i[0] = (yyvsp[0].intval);
                                if (!((yyval.list) = make_list(&c->node)))
                                    YYABORT;
                            }
#line 4566 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 115: /* primary_expr: boolean  */
#line 2303 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_ir_constant *c = d3dcompiler_alloc(sizeof(*c));
                                if (!c)
                                {
                                    ERR("Out of memory.\n");
                                    YYABORT;
                                }
                                init_node(&c->node, HLSL_IR_CONSTANT,
                                        hlsl_ctx.builtin_types.scalar[HLSL_TYPE_BOOL], get_location(&(yylsp[0])));
                                c->value.b[0] = (yyvsp[0].boolval);
                                if (!((yyval.list) = make_list(&c->node)))
                                    YYABORT;
                            }
#line 4584 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 116: /* primary_expr: VAR_IDENTIFIER  */
#line 2317 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_ir_load *load;
                                struct hlsl_ir_var *var;

                                if (!(var = get_variable(hlsl_ctx.cur_scope, (yyvsp[0].name))))
                                {
                                    hlsl_report_message(get_location(&(yylsp[0])), HLSL_LEVEL_ERROR,
                                            "variable '%s' is not declared\n", (yyvsp[0].name));
                                    YYABORT;
                                }
                                if ((load = new_var_load(var, get_location(&(yylsp[0])))))
                                {
                                    if (!((yyval.list) = make_list(&load->node)))
                                        YYABORT;
                                }
                                else
                                    (yyval.list) = NULL;
                            }
#line 4607 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 117: /* primary_expr: '(' expr ')'  */
#line 2336 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-1].list);
                            }
#line 4615 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 118: /* postfix_expr: primary_expr  */
#line 2341 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4623 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 119: /* postfix_expr: postfix_expr OP_INC  */
#line 2345 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct source_location loc;
                                struct hlsl_ir_node *inc;

                                loc = get_location(&(yylsp[0]));
                                if (node_from_list((yyvsp[-1].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifying a const expression");
                                    YYABORT;
                                }
                                inc = new_unary_expr(HLSL_IR_UNOP_POSTINC, node_from_list((yyvsp[-1].list)), loc);
                                /* Post increment/decrement expressions are considered const */
                                inc->data_type = clone_hlsl_type(inc->data_type, 0);
                                inc->data_type->modifiers |= HLSL_MODIFIER_CONST;
                                (yyval.list) = append_unop((yyvsp[-1].list), inc);
                            }
#line 4644 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 120: /* postfix_expr: postfix_expr OP_DEC  */
#line 2362 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct source_location loc;
                                struct hlsl_ir_node *inc;

                                loc = get_location(&(yylsp[0]));
                                if (node_from_list((yyvsp[-1].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifying a const expression");
                                    YYABORT;
                                }
                                inc = new_unary_expr(HLSL_IR_UNOP_POSTDEC, node_from_list((yyvsp[-1].list)), loc);
                                /* Post increment/decrement expressions are considered const */
                                inc->data_type = clone_hlsl_type(inc->data_type, 0);
                                inc->data_type->modifiers |= HLSL_MODIFIER_CONST;
                                (yyval.list) = append_unop((yyvsp[-1].list), inc);
                            }
#line 4665 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 121: /* postfix_expr: postfix_expr '.' any_identifier  */
#line 2379 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_ir_node *node = node_from_list((yyvsp[-2].list));
                                struct source_location loc;

                                loc = get_location(&(yylsp[-1]));
                                if (node->data_type->type == HLSL_CLASS_STRUCT)
                                {
                                    struct hlsl_type *type = node->data_type;
                                    struct hlsl_struct_field *field;

                                    (yyval.list) = NULL;
                                    LIST_FOR_EACH_ENTRY(field, type->e.elements, struct hlsl_struct_field, entry)
                                    {
                                        if (!strcmp((yyvsp[0].name), field->name))
                                        {
                                            if (!add_record_load((yyvsp[-2].list), node, field, loc))
                                                YYABORT;
                                            (yyval.list) = (yyvsp[-2].list);
                                            break;
                                        }
                                    }
                                    if (!(yyval.list))
                                    {
                                        hlsl_report_message(loc, HLSL_LEVEL_ERROR,
                                                "invalid subscript %s", debugstr_a((yyvsp[0].name)));
                                        YYABORT;
                                    }
                                }
                                else if (node->data_type->type <= HLSL_CLASS_LAST_NUMERIC)
                                {
                                    struct hlsl_ir_swizzle *swizzle;

                                    swizzle = get_swizzle(node, (yyvsp[0].name), &loc);
                                    if (!swizzle)
                                    {
                                        hlsl_report_message(loc, HLSL_LEVEL_ERROR,
                                                "invalid swizzle %s", debugstr_a((yyvsp[0].name)));
                                        YYABORT;
                                    }
                                    (yyval.list) = append_unop((yyvsp[-2].list), &swizzle->node);
                                }
                                else
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR,
                                            "invalid subscript %s", debugstr_a((yyvsp[0].name)));
                                    YYABORT;
                                }
                            }
#line 4718 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 122: /* postfix_expr: postfix_expr '[' expr ']'  */
#line 2428 "dlls/d3dcompiler_43/hlsl.y"
        {
            struct hlsl_ir_node *array = node_from_list((yyvsp[-3].list)), *index = node_from_list((yyvsp[-1].list));

            list_move_tail((yyvsp[-3].list), (yyvsp[-1].list));
            d3dcompiler_free((yyvsp[-1].list));

            if (index->data_type->type != HLSL_CLASS_SCALAR)
            {
                hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR, "array index is not scalar");
                free_instr_list((yyvsp[-3].list));
                YYABORT;
            }

            if (!add_array_load((yyvsp[-3].list), array, index, get_location(&(yylsp[-2]))))
            {
                free_instr_list((yyvsp[-3].list));
                YYABORT;
            }
            (yyval.list) = (yyvsp[-3].list);
        }
#line 4743 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 123: /* postfix_expr: var_modifiers type '(' initializer_expr_list ')'  */
#line 2452 "dlls/d3dcompiler_43/hlsl.y"
        {
            struct hlsl_ir_assignment *assignment;
            unsigned int i, writemask_offset = 0;
            static unsigned int counter;
            struct hlsl_ir_load *load;
            struct hlsl_ir_var *var;
            char name[23];

            if ((yyvsp[-4].modifiers))
            {
                hlsl_report_message(get_location(&(yylsp[-4])), HLSL_LEVEL_ERROR,
                        "unexpected modifier on a constructor\n");
                YYABORT;
            }
            if ((yyvsp[-3].type)->type > HLSL_CLASS_LAST_NUMERIC)
            {
                hlsl_report_message(get_location(&(yylsp[-3])), HLSL_LEVEL_ERROR,
                        "constructors may only be used with numeric data types\n");
                YYABORT;
            }
            if ((yyvsp[-3].type)->dimx * (yyvsp[-3].type)->dimy != initializer_size(&(yyvsp[-1].initializer)))
            {
                hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR,
                        "expected %u components in constructor, but got %u\n",
                        (yyvsp[-3].type)->dimx * (yyvsp[-3].type)->dimy, initializer_size(&(yyvsp[-1].initializer)));
                YYABORT;
            }

            if ((yyvsp[-3].type)->type == HLSL_CLASS_MATRIX)
                FIXME("Matrix constructors are not supported yet.\n");

            sprintf(name, "<constructor-%x>", counter++);
            if (!(var = new_synthetic_var(name, (yyvsp[-3].type), get_location(&(yylsp[-3])))))
                YYABORT;
            for (i = 0; i < (yyvsp[-1].initializer).args_count; ++i)
            {
                struct hlsl_ir_node *arg = (yyvsp[-1].initializer).args[i];
                unsigned int width;

                if (arg->data_type->type == HLSL_CLASS_OBJECT)
                {
                    hlsl_report_message(arg->loc, HLSL_LEVEL_ERROR,
                            "invalid constructor argument");
                    continue;
                }
                width = components_count_type(arg->data_type);

                if (width > 4)
                {
                    FIXME("Constructor argument with %u components.\n", width);
                    continue;
                }

                if (!(arg = add_implicit_conversion((yyvsp[-1].initializer).instrs, arg,
                        hlsl_ctx.builtin_types.vector[(yyvsp[-3].type)->base_type][width - 1], &arg->loc)))
                    continue;

                if (!(assignment = new_assignment(var, NULL, arg,
                        ((1 << width) - 1) << writemask_offset, arg->loc)))
                    YYABORT;
                writemask_offset += width;
                list_add_tail((yyvsp[-1].initializer).instrs, &assignment->node.entry);
            }
            d3dcompiler_free((yyvsp[-1].initializer).args);
            if (!(load = new_var_load(var, get_location(&(yylsp[-3])))))
                YYABORT;
            (yyval.list) = append_unop((yyvsp[-1].initializer).instrs, &load->node);
        }
#line 4816 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 124: /* unary_expr: postfix_expr  */
#line 2522 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4824 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 125: /* unary_expr: OP_INC unary_expr  */
#line 2526 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct source_location loc;

                                loc = get_location(&(yylsp[-1]));
                                if (node_from_list((yyvsp[0].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifying a const expression");
                                    YYABORT;
                                }
                                (yyval.list) = append_unop((yyvsp[0].list), new_unary_expr(HLSL_IR_UNOP_PREINC, node_from_list((yyvsp[0].list)), loc));
                            }
#line 4840 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 126: /* unary_expr: OP_DEC unary_expr  */
#line 2538 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct source_location loc;

                                loc = get_location(&(yylsp[-1]));
                                if (node_from_list((yyvsp[0].list))->data_type->modifiers & HLSL_MODIFIER_CONST)
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "modifying a const expression");
                                    YYABORT;
                                }
                                (yyval.list) = append_unop((yyvsp[0].list), new_unary_expr(HLSL_IR_UNOP_PREDEC, node_from_list((yyvsp[0].list)), loc));
                            }
#line 4856 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 127: /* unary_expr: unary_op unary_expr  */
#line 2550 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                enum hlsl_ir_expr_op ops[] = {0, HLSL_IR_UNOP_NEG,
                                        HLSL_IR_UNOP_LOGIC_NOT, HLSL_IR_UNOP_BIT_NOT};

                                if ((yyvsp[-1].unary_op) == UNARY_OP_PLUS)
                                {
                                    (yyval.list) = (yyvsp[0].list);
                                }
                                else
                                {
                                    (yyval.list) = append_unop((yyvsp[0].list), new_unary_expr(ops[(yyvsp[-1].unary_op)], node_from_list((yyvsp[0].list)), get_location(&(yylsp[-1]))));
                                }
                            }
#line 4874 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 128: /* unary_expr: '(' var_modifiers type array ')' unary_expr  */
#line 2565 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                struct hlsl_type *src_type = node_from_list((yyvsp[0].list))->data_type;
                                struct hlsl_type *dst_type;
                                struct source_location loc;

                                loc = get_location(&(yylsp[-3]));
                                if ((yyvsp[-4].modifiers))
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "unexpected modifier in a cast");
                                    YYABORT;
                                }

                                if ((yyvsp[-2].intval))
                                    dst_type = new_array_type((yyvsp[-3].type), (yyvsp[-2].intval));
                                else
                                    dst_type = (yyvsp[-3].type);

                                if (!compatible_data_types(src_type, dst_type))
                                {
                                    hlsl_report_message(loc, HLSL_LEVEL_ERROR, "can't cast from %s to %s",
                                            debug_hlsl_type(src_type), debug_hlsl_type(dst_type));
                                    YYABORT;
                                }

                                (yyval.list) = append_unop((yyvsp[0].list), &new_cast(node_from_list((yyvsp[0].list)), dst_type, &loc)->node);
                            }
#line 4905 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 129: /* unary_op: '+'  */
#line 2593 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.unary_op) = UNARY_OP_PLUS;
                            }
#line 4913 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 130: /* unary_op: '-'  */
#line 2597 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.unary_op) = UNARY_OP_MINUS;
                            }
#line 4921 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 131: /* unary_op: '!'  */
#line 2601 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.unary_op) = UNARY_OP_LOGICNOT;
                            }
#line 4929 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 132: /* unary_op: '~'  */
#line 2605 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.unary_op) = UNARY_OP_BITNOT;
                            }
#line 4937 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 134: /* mul_expr: mul_expr '*' unary_expr  */
#line 2613 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_MUL, get_location(&(yylsp[-1])));
        }
#line 4945 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 135: /* mul_expr: mul_expr '/' unary_expr  */
#line 2617 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_DIV, get_location(&(yylsp[-1])));
        }
#line 4953 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 136: /* mul_expr: mul_expr '%' unary_expr  */
#line 2621 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_MOD, get_location(&(yylsp[-1])));
        }
#line 4961 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 138: /* add_expr: add_expr '+' mul_expr  */
#line 2629 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_ADD, get_location(&(yylsp[-1])));
        }
#line 4969 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 139: /* add_expr: add_expr '-' mul_expr  */
#line 2633 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_SUB, get_location(&(yylsp[-1])));
        }
#line 4977 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 140: /* shift_expr: add_expr  */
#line 2638 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 4985 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 141: /* shift_expr: shift_expr OP_LEFTSHIFT add_expr  */
#line 2642 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("Left shift\n");
                            }
#line 4993 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 142: /* shift_expr: shift_expr OP_RIGHTSHIFT add_expr  */
#line 2646 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("Right shift\n");
                            }
#line 5001 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 144: /* relational_expr: relational_expr '<' shift_expr  */
#line 2654 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_LESS, get_location(&(yylsp[-1])));
        }
#line 5009 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 145: /* relational_expr: relational_expr '>' shift_expr  */
#line 2658 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_GREATER, get_location(&(yylsp[-1])));
        }
#line 5017 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 146: /* relational_expr: relational_expr OP_LE shift_expr  */
#line 2662 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_LEQUAL, get_location(&(yylsp[-1])));
        }
#line 5025 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 147: /* relational_expr: relational_expr OP_GE shift_expr  */
#line 2666 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_GEQUAL, get_location(&(yylsp[-1])));
        }
#line 5033 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 149: /* equality_expr: equality_expr OP_EQ relational_expr  */
#line 2674 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_EQUAL, get_location(&(yylsp[-1])));
        }
#line 5041 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 150: /* equality_expr: equality_expr OP_NE relational_expr  */
#line 2678 "dlls/d3dcompiler_43/hlsl.y"
        {
            (yyval.list) = add_binary_expr((yyvsp[-2].list), (yyvsp[0].list), HLSL_IR_BINOP_NEQUAL, get_location(&(yylsp[-1])));
        }
#line 5049 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 151: /* bitand_expr: equality_expr  */
#line 2683 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 5057 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 152: /* bitand_expr: bitand_expr '&' equality_expr  */
#line 2687 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("bitwise AND\n");
                            }
#line 5065 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 153: /* bitxor_expr: bitand_expr  */
#line 2692 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 5073 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 154: /* bitxor_expr: bitxor_expr '^' bitand_expr  */
#line 2696 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("bitwise XOR\n");
                            }
#line 5081 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 155: /* bitor_expr: bitxor_expr  */
#line 2701 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 5089 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 156: /* bitor_expr: bitor_expr '|' bitxor_expr  */
#line 2705 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("bitwise OR\n");
                            }
#line 5097 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 157: /* logicand_expr: bitor_expr  */
#line 2710 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 5105 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 158: /* logicand_expr: logicand_expr OP_AND bitor_expr  */
#line 2714 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("logic AND\n");
                            }
#line 5113 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 159: /* logicor_expr: logicand_expr  */
#line 2719 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 5121 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 160: /* logicor_expr: logicor_expr OP_OR logicand_expr  */
#line 2723 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("logic OR\n");
                            }
#line 5129 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 161: /* conditional_expr: logicor_expr  */
#line 2728 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 5137 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 162: /* conditional_expr: logicor_expr '?' expr ':' assignment_expr  */
#line 2732 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                FIXME("ternary operator\n");
                            }
#line 5145 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 164: /* assignment_expr: unary_expr assign_op assignment_expr  */
#line 2740 "dlls/d3dcompiler_43/hlsl.y"
        {
            struct hlsl_ir_node *lhs = node_from_list((yyvsp[-2].list)), *rhs = node_from_list((yyvsp[0].list));

            if (lhs->data_type->modifiers & HLSL_MODIFIER_CONST)
            {
                hlsl_report_message(get_location(&(yylsp[-1])), HLSL_LEVEL_ERROR, "l-value is const");
                YYABORT;
            }
            list_move_tail((yyvsp[0].list), (yyvsp[-2].list));
            d3dcompiler_free((yyvsp[-2].list));
            if (!add_assignment((yyvsp[0].list), lhs, (yyvsp[-1].assign_op), rhs))
                YYABORT;
            (yyval.list) = (yyvsp[0].list);
        }
#line 5164 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 165: /* assign_op: '='  */
#line 2756 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_ASSIGN;
                            }
#line 5172 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 166: /* assign_op: OP_ADDASSIGN  */
#line 2760 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_ADD;
                            }
#line 5180 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 167: /* assign_op: OP_SUBASSIGN  */
#line 2764 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_SUB;
                            }
#line 5188 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 168: /* assign_op: OP_MULASSIGN  */
#line 2768 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_MUL;
                            }
#line 5196 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 169: /* assign_op: OP_DIVASSIGN  */
#line 2772 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_DIV;
                            }
#line 5204 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 170: /* assign_op: OP_MODASSIGN  */
#line 2776 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_MOD;
                            }
#line 5212 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 171: /* assign_op: OP_LEFTSHIFTASSIGN  */
#line 2780 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_LSHIFT;
                            }
#line 5220 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 172: /* assign_op: OP_RIGHTSHIFTASSIGN  */
#line 2784 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_RSHIFT;
                            }
#line 5228 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 173: /* assign_op: OP_ANDASSIGN  */
#line 2788 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_AND;
                            }
#line 5236 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 174: /* assign_op: OP_ORASSIGN  */
#line 2792 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_OR;
                            }
#line 5244 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 175: /* assign_op: OP_XORASSIGN  */
#line 2796 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.assign_op) = ASSIGN_OP_XOR;
                            }
#line 5252 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 176: /* expr: assignment_expr  */
#line 2801 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[0].list);
                            }
#line 5260 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;

  case 177: /* expr: expr ',' assignment_expr  */
#line 2805 "dlls/d3dcompiler_43/hlsl.y"
                            {
                                (yyval.list) = (yyvsp[-2].list);
                                list_move_tail((yyval.list), (yyvsp[0].list));
                                d3dcompiler_free((yyvsp[0].list));
                            }
#line 5270 "dlls/d3dcompiler_35/hlsl.tab.c"
    break;


#line 5274 "dlls/d3dcompiler_35/hlsl.tab.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken, &yylloc};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          goto yyexhaustedlab;
      }
    }

  yyerror_range[1] = yylloc;
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  ++yylsp;
  YYLLOC_DEFAULT (*yylsp, yyerror_range, 2);

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if 1
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturn;
#endif


/*-------------------------------------------------------.
| yyreturn -- parsing is finished, clean up and return.  |
`-------------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 2811 "dlls/d3dcompiler_43/hlsl.y"


static struct source_location get_location(const struct YYLTYPE *l)
{
    const struct source_location loc =
    {
        .file = hlsl_ctx.source_file,
        .line = l->first_line,
        .col = l->first_column,
    };
    return loc;
}

static void dump_function_decl(struct wine_rb_entry *entry, void *context)
{
    struct hlsl_ir_function_decl *func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function_decl, entry);
    if (func->body)
        debug_dump_ir_function_decl(func);
}

static void dump_function(struct wine_rb_entry *entry, void *context)
{
    struct hlsl_ir_function *func = WINE_RB_ENTRY_VALUE(entry, struct hlsl_ir_function, entry);
    wine_rb_for_each_entry(&func->overloads, dump_function_decl, NULL);
}

/* Allocate a unique, ordered index to each instruction, which will be used for
 * computing liveness ranges. */
static unsigned int index_instructions(struct list *instrs, unsigned int index)
{
    struct hlsl_ir_node *instr;

    LIST_FOR_EACH_ENTRY(instr, instrs, struct hlsl_ir_node, entry)
    {
        instr->index = index++;

        if (instr->type == HLSL_IR_IF)
        {
            struct hlsl_ir_if *iff = if_from_node(instr);
            index = index_instructions(&iff->then_instrs, index);
            index = index_instructions(&iff->else_instrs, index);
        }
        else if (instr->type == HLSL_IR_LOOP)
        {
            index = index_instructions(&loop_from_node(instr)->body, index);
            loop_from_node(instr)->next_index = index;
        }
    }

    return index;
}

/* Compute the earliest and latest liveness for each variable. In the case that
 * a variable is accessed inside of a loop, we promote its liveness to extend
 * to at least the range of the entire loop. Note that we don't need to do this
 * for anonymous nodes, since there's currently no way to use a node which was
 * calculated in an earlier iteration of the loop. */
static void compute_liveness_recurse(struct list *instrs, unsigned int loop_first, unsigned int loop_last)
{
    struct hlsl_ir_node *instr;
    struct hlsl_ir_var *var;

    LIST_FOR_EACH_ENTRY(instr, instrs, struct hlsl_ir_node, entry)
    {
        switch (instr->type)
        {
        case HLSL_IR_ASSIGNMENT:
        {
            struct hlsl_ir_assignment *assignment = assignment_from_node(instr);
            var = assignment->lhs.var;
            if (!var->first_write)
                var->first_write = loop_first ? min(instr->index, loop_first) : instr->index;
            assignment->rhs.node->last_read = instr->index;
            if (assignment->lhs.offset.node)
                assignment->lhs.offset.node->last_read = instr->index;
            break;
        }
        case HLSL_IR_EXPR:
        {
            struct hlsl_ir_expr *expr = expr_from_node(instr);
            unsigned int i;

            for (i = 0; i < ARRAY_SIZE(expr->operands) && expr->operands[i].node; ++i)
                expr->operands[i].node->last_read = instr->index;
            break;
        }
        case HLSL_IR_IF:
        {
            struct hlsl_ir_if *iff = if_from_node(instr);
            compute_liveness_recurse(&iff->then_instrs, loop_first, loop_last);
            compute_liveness_recurse(&iff->else_instrs, loop_first, loop_last);
            iff->condition.node->last_read = instr->index;
            break;
        }
        case HLSL_IR_LOAD:
        {
            struct hlsl_ir_load *load = load_from_node(instr);
            var = load->src.var;
            var->last_read = loop_last ? max(instr->index, loop_last) : instr->index;
            if (load->src.offset.node)
                load->src.offset.node->last_read = instr->index;
            break;
        }
        case HLSL_IR_LOOP:
        {
            struct hlsl_ir_loop *loop = loop_from_node(instr);
            compute_liveness_recurse(&loop->body, loop_first ? loop_first : instr->index,
                    loop_last ? loop_last : loop->next_index);
            break;
        }
        case HLSL_IR_SWIZZLE:
        {
            struct hlsl_ir_swizzle *swizzle = swizzle_from_node(instr);
            swizzle->val.node->last_read = instr->index;
            break;
        }
        case HLSL_IR_CONSTANT:
        case HLSL_IR_JUMP:
            break;
        }
    }
}

static void compute_liveness(struct hlsl_ir_function_decl *entry_func)
{
    struct hlsl_ir_var *var;

    LIST_FOR_EACH_ENTRY(var, &hlsl_ctx.globals->vars, struct hlsl_ir_var, scope_entry)
    {
        var->first_write = 1;
    }

    LIST_FOR_EACH_ENTRY(var, entry_func->parameters, struct hlsl_ir_var, param_entry)
    {
        if (var->modifiers & HLSL_STORAGE_IN)
            var->first_write = 1;
        if (var->modifiers & HLSL_STORAGE_OUT)
            var->last_read = UINT_MAX;
    }

    if (entry_func->return_var)
        entry_func->return_var->last_read = UINT_MAX;

    compute_liveness_recurse(entry_func->body, 0, 0);
}

HRESULT parse_hlsl(enum shader_type type, DWORD major, DWORD minor,
        const char *entrypoint, ID3D10Blob **shader_blob, char **messages)
{
    struct hlsl_ir_function_decl *entry_func;
    struct hlsl_scope *scope, *next_scope;
    struct hlsl_type *hlsl_type, *next_type;
    struct hlsl_ir_var *var, *next_var;
    HRESULT hr = E_FAIL;
    unsigned int i;

    hlsl_ctx.status = PARSE_SUCCESS;
    hlsl_ctx.messages.size = hlsl_ctx.messages.capacity = 0;
    hlsl_ctx.line_no = hlsl_ctx.column = 1;
    hlsl_ctx.source_file = d3dcompiler_strdup("");
    hlsl_ctx.source_files = d3dcompiler_alloc(sizeof(*hlsl_ctx.source_files));
    if (hlsl_ctx.source_files)
        hlsl_ctx.source_files[0] = hlsl_ctx.source_file;
    hlsl_ctx.source_files_count = 1;
    hlsl_ctx.cur_scope = NULL;
    hlsl_ctx.matrix_majority = HLSL_COLUMN_MAJOR;
    list_init(&hlsl_ctx.scopes);
    list_init(&hlsl_ctx.types);
    init_functions_tree(&hlsl_ctx.functions);
    list_init(&hlsl_ctx.static_initializers);

    push_scope(&hlsl_ctx);
    hlsl_ctx.globals = hlsl_ctx.cur_scope;
    declare_predefined_types(hlsl_ctx.globals);

    hlsl_parse();

    if (hlsl_ctx.status == PARSE_ERR)
        goto out;

    if (!(entry_func = get_func_entry(entrypoint)))
    {
        hlsl_message("error: entry point %s is not defined\n", debugstr_a(entrypoint));
        goto out;
    }

    if (!type_is_void(entry_func->return_type)
            && entry_func->return_type->type != HLSL_CLASS_STRUCT && !entry_func->semantic)
    {
        hlsl_report_message(entry_func->loc, HLSL_LEVEL_ERROR,
                "entry point \"%s\" is missing a return value semantic", entry_func->func->name);
    }

    list_move_head(entry_func->body, &hlsl_ctx.static_initializers);

    /* Index 0 means unused; index 1 means function entry, so start at 2. */
    index_instructions(entry_func->body, 2);

    if (TRACE_ON(hlsl_parser))
    {
        TRACE("IR dump.\n");
        wine_rb_for_each_entry(&hlsl_ctx.functions, dump_function, NULL);
    }

    compute_liveness(entry_func);

    if (hlsl_ctx.status != PARSE_ERR)
        hr = E_NOTIMPL;

out:
    if (messages)
    {
        if (hlsl_ctx.messages.size)
            *messages = hlsl_ctx.messages.string;
        else
            *messages = NULL;
    }
    else
    {
        if (hlsl_ctx.messages.capacity)
            d3dcompiler_free(hlsl_ctx.messages.string);
    }

    for (i = 0; i < hlsl_ctx.source_files_count; ++i)
        d3dcompiler_free((void *)hlsl_ctx.source_files[i]);
    d3dcompiler_free(hlsl_ctx.source_files);

    TRACE("Freeing functions IR.\n");
    wine_rb_destroy(&hlsl_ctx.functions, free_function_rb, NULL);

    TRACE("Freeing variables.\n");
    LIST_FOR_EACH_ENTRY_SAFE(scope, next_scope, &hlsl_ctx.scopes, struct hlsl_scope, entry)
    {
        LIST_FOR_EACH_ENTRY_SAFE(var, next_var, &scope->vars, struct hlsl_ir_var, scope_entry)
        {
            free_declaration(var);
        }
        wine_rb_destroy(&scope->types, NULL, NULL);
        d3dcompiler_free(scope);
    }

    TRACE("Freeing types.\n");
    LIST_FOR_EACH_ENTRY_SAFE(hlsl_type, next_type, &hlsl_ctx.types, struct hlsl_type, entry)
    {
        free_hlsl_type(hlsl_type);
    }

    return hr;
}
